(set-logic QF_NIA)
(set-info
  :source |
SMT script generated by Ultimate LassoRanker [1].
Ultimate LassoRanker is a tool that analyzes termination and nontermination of 
lasso-shaped programs. This script contains the SMT commands that Ultimate 
LassoRanker used while checking if a lasso-shaped program has a geometric 
nontermination argument [2].

This SMT script belongs to a set of SMT scripts that was generated by applying
Ultimate Buchi Automizer [3,4] to the benchmarks from the SV-COMP 2015 [5,6] 
which are available at [7]. Ultimate Buchi Automizer takes omega-traces
(lasso-shaped programs) and uses LassoRanker in order to check if the 
lasso-shaped program is terminating.

2015-04-30, Matthias Heizmann (heizmann@informatik.uni-freiburg.de)


[1] https://ultimate.informatik.uni-freiburg.de/LassoRanker/
[2] Jan Leike, Matthias Heizmann:
Geometric Series as Nontermination Arguments for Linear Lasso Programs. 
CoRR abs/1405.4413 (2014)
http://arxiv.org/abs/1405.4413
[3] http://ultimate.informatik.uni-freiburg.de/BuchiAutomizer/
[4] Matthias Heizmann, Jochen Hoenicke, Andreas Podelski: Software Model 
Checking for People Who Love Automata. CAV 2013:36-52
[5] http://sv-comp.sosy-lab.org/2015/
[6] Dirk Beyer: Software Verification and Verifiable Witnesses - (Report on 
SV-COMP 2015). TACAS 2015: 401-416
[7] https://svn.sosy-lab.org/software/sv-benchmarks/tags/svcomp15/
|)
(set-info :smt-lib-version 2.0)
(set-info :category "industrial")
(set-info :status unsat)
(declare-fun |init_test_fun_#t~malloc2.base| () Int)
(declare-fun |honda_test_fun_#t~malloc2.base| () Int)
(declare-fun |ray_test_fun_#t~malloc2.base| () Int)
(declare-fun init_test_fun_~c~2.base () Int)
(declare-fun honda_test_fun_~c~2.base () Int)
(declare-fun ray_test_fun_~c~2.base () Int)
(declare-fun |init_test_fun_#in~y| () Int)
(declare-fun |honda_test_fun_#in~y| () Int)
(declare-fun |ray_test_fun_#in~y| () Int)
(declare-fun |init_test_fun_#t~mem6| () Int)
(declare-fun |honda_test_fun_#t~mem6| () Int)
(declare-fun |ray_test_fun_#t~mem6| () Int)
(declare-fun |init_test_fun_#t~malloc1.base| () Int)
(declare-fun |honda_test_fun_#t~malloc1.base| () Int)
(declare-fun |ray_test_fun_#t~malloc1.base| () Int)
(declare-fun |init_test_fun_#t~malloc2.offset| () Int)
(declare-fun |honda_test_fun_#t~malloc2.offset| () Int)
(declare-fun |ray_test_fun_#t~malloc2.offset| () Int)
(declare-fun |init_test_fun_#t~mem7| () Int)
(declare-fun |honda_test_fun_#t~mem7| () Int)
(declare-fun |ray_test_fun_#t~mem7| () Int)
(declare-fun |init_test_fun_#t~mem16| () Int)
(declare-fun |honda_test_fun_#t~mem16| () Int)
(declare-fun |ray_test_fun_#t~mem16| () Int)
(declare-fun init_test_fun_~y () Int)
(declare-fun honda_test_fun_~y () Int)
(declare-fun ray_test_fun_~y () Int)
(declare-fun |init_test_fun_#t~malloc0.offset| () Int)
(declare-fun |honda_test_fun_#t~malloc0.offset| () Int)
(declare-fun |ray_test_fun_#t~malloc0.offset| () Int)
(declare-fun init_test_fun_~y_ref~2.base () Int)
(declare-fun honda_test_fun_~y_ref~2.base () Int)
(declare-fun ray_test_fun_~y_ref~2.base () Int)
(declare-fun init_test_fun_~x () Int)
(declare-fun honda_test_fun_~x () Int)
(declare-fun ray_test_fun_~x () Int)
(declare-fun |init_test_fun_#t~malloc0.base| () Int)
(declare-fun |honda_test_fun_#t~malloc0.base| () Int)
(declare-fun |ray_test_fun_#t~malloc0.base| () Int)
(declare-fun |init_test_fun_#t~mem18| () Int)
(declare-fun |honda_test_fun_#t~mem18| () Int)
(declare-fun |ray_test_fun_#t~mem18| () Int)
(declare-fun |init_test_fun_#t~malloc1.offset| () Int)
(declare-fun |honda_test_fun_#t~malloc1.offset| () Int)
(declare-fun |ray_test_fun_#t~malloc1.offset| () Int)
(declare-fun init_test_fun_~x_ref~2.base () Int)
(declare-fun honda_test_fun_~x_ref~2.base () Int)
(declare-fun ray_test_fun_~x_ref~2.base () Int)
(declare-fun |init_test_fun_#t~mem11| () Int)
(declare-fun |honda_test_fun_#t~mem11| () Int)
(declare-fun |ray_test_fun_#t~mem11| () Int)
(declare-fun init_test_fun_~y_ref~2.offset () Int)
(declare-fun honda_test_fun_~y_ref~2.offset () Int)
(declare-fun ray_test_fun_~y_ref~2.offset () Int)
(declare-fun |init_test_fun_#t~mem15| () Int)
(declare-fun |honda_test_fun_#t~mem15| () Int)
(declare-fun |ray_test_fun_#t~mem15| () Int)
(declare-fun |init_test_fun_#t~mem12| () Int)
(declare-fun |honda_test_fun_#t~mem12| () Int)
(declare-fun |ray_test_fun_#t~mem12| () Int)
(declare-fun |init_#NULL.offset| () Int)
(declare-fun |honda_#NULL.offset| () Int)
(declare-fun |ray_#NULL.offset| () Int)
(declare-fun |init_test_fun_#in~x| () Int)
(declare-fun |honda_test_fun_#in~x| () Int)
(declare-fun |ray_test_fun_#in~x| () Int)
(declare-fun |init_test_fun_#t~mem13| () Int)
(declare-fun |honda_test_fun_#t~mem13| () Int)
(declare-fun |ray_test_fun_#t~mem13| () Int)
(declare-fun init_test_fun_~x_ref~2.offset () Int)
(declare-fun honda_test_fun_~x_ref~2.offset () Int)
(declare-fun ray_test_fun_~x_ref~2.offset () Int)
(declare-fun init_test_fun_~c~2.offset () Int)
(declare-fun honda_test_fun_~c~2.offset () Int)
(declare-fun ray_test_fun_~c~2.offset () Int)
(declare-fun |init_#NULL.base| () Int)
(declare-fun |honda_#NULL.base| () Int)
(declare-fun |ray_#NULL.base| () Int)
(declare-fun |init_(ite test_fun_#t~short8 1 0)| () Int)
(declare-fun |honda_(ite test_fun_#t~short8 1 0)| () Int)
(declare-fun |ray_(ite test_fun_#t~short8 1 0)| () Int)
(declare-fun |init_(ite (select #valid 0) 1 0)| () Int)
(declare-fun |honda_(ite (select #valid 0) 1 0)| () Int)
(declare-fun |ray_(ite (select #valid 0) 1 0)| () Int)
(declare-fun
  |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
  () Int)
(declare-fun
  |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
  () Int)
(declare-fun
  |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
  () Int)
(declare-fun
  |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
  () Int)
(declare-fun
  |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
  () Int)
(declare-fun
  |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
  () Int)
(declare-fun
  |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
  () Int)
(declare-fun
  |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
  () Int)
(declare-fun
  |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
  () Int)
(declare-fun
  |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
  () Int)
(declare-fun
  |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
  () Int)
(declare-fun
  |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
  () Int)
(declare-fun |honda_(select old(#length) test_fun_~y_ref~2.base)| () Int)
(declare-fun |ray_(select old(#length) test_fun_~y_ref~2.base)| () Int)
(declare-fun |honda_(select old(#length) test_fun_~c~2.base)| () Int)
(declare-fun |ray_(select old(#length) test_fun_~c~2.base)| () Int)
(declare-fun |honda_(select old(#length) test_fun_~x_ref~2.base)| () Int)
(declare-fun |ray_(select old(#length) test_fun_~x_ref~2.base)| () Int)
(declare-fun |honda_(select #length test_fun_~y_ref~2.base)| () Int)
(declare-fun |ray_(select #length test_fun_~y_ref~2.base)| () Int)
(declare-fun |honda_(select #length test_fun_~c~2.base)| () Int)
(declare-fun |ray_(select #length test_fun_~c~2.base)| () Int)
(declare-fun |honda_(select #length test_fun_~x_ref~2.base)| () Int)
(declare-fun |ray_(select #length test_fun_~x_ref~2.base)| () Int)
(declare-fun |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| () Int)
(declare-fun |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| () Int)
(declare-fun |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| () Int)
(declare-fun |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| () Int)
(declare-fun |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| () Int)
(declare-fun |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| () Int)
(declare-fun |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| ()
  Int)
(declare-fun |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| ()
  Int)
(declare-fun |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| ()
  Int)
(declare-fun |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| () Int)
(declare-fun |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| ()
  Int)
(declare-fun |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| ()
  Int)
(declare-fun |honda_(ite (select old(#valid) 0) 1 0)| () Int)
(declare-fun |ray_(ite (select old(#valid) 0) 1 0)| () Int)
(declare-fun lambda () Int)
(assert
 (and
 (or
 (and
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 1) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| (- 1)) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 1)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 1) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0)
 (* honda_test_fun_~x_ref~2.base (- 1)) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| (- 1)) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| (- 1)) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 1) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y (- 1)) 
 (* |honda_test_fun_#t~malloc0.offset| 0) 
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset (- 1)) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 1) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| (- 1)) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 1)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 1) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 1) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset (- 1)) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 (- 1))
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 1) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 1) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 1)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| (- 1))
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 1)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| (- 1))
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 1)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 1) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y (- 1)) 
 (* |honda_test_fun_#t~malloc0.offset| 0) 
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 1)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x (- 1)) 
 (* |honda_test_fun_#t~malloc0.base| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 1) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base (- 1)) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 1) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 1) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset (- 1)) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 1) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset (- 1)) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 1)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 1) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| (- 1))
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 1) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset (- 1)) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 1) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| (- 1))
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0))
 (and
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 1) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| (- 1)) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 1)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| (- 1)) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| (- 1)) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 1) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y (- 1)) 
 (* |honda_test_fun_#t~malloc0.offset| 0) 
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset (- 1)) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 1) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| (- 1)) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 1)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 1) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 1) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset (- 1)) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 (- 1))
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 1) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0)
 (* honda_test_fun_~x_ref~2.base (- 1)) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 1)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| (- 1))
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 1)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| (- 1))
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 1)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 1) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y (- 1)) 
 (* |honda_test_fun_#t~malloc0.offset| 0) 
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 1)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base (- 1)) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 1) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x (- 1)) 
 (* |honda_test_fun_#t~malloc0.base| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 1) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 1) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 1) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset (- 1)) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 1) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset (- 1)) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 1) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base (- 1)) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 1)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 1) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| (- 1))
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 1) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset (- 1)) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 1) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| (- 1))
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0))
 (and
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 1) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| (- 1)) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 1)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 1) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0)
 (* honda_test_fun_~x_ref~2.base (- 1)) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| (- 1)) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| (- 1)) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 1) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y (- 1)) 
 (* |honda_test_fun_#t~malloc0.offset| 0) 
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset (- 1)) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 1) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| (- 1)) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 1)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 1) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 1) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset (- 1)) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 (- 1))
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 1) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 1)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| (- 1))
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base (- 1)) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 1)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| (- 1))
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 1)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 1) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y (- 1)) 
 (* |honda_test_fun_#t~malloc0.offset| 0) 
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 1)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x (- 1)) 
 (* |honda_test_fun_#t~malloc0.base| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 1) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 1) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 1) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset (- 1)) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 1) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset (- 1)) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 1) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base (- 1)) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 1)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 1) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| (- 1))
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 1) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset (- 1)) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 1) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| (- 1))
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0))
 (and
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 1) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| (- 1)) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 1)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 1) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0)
 (* honda_test_fun_~x_ref~2.base (- 1)) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| (- 1)) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 1) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| (- 1)) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 1) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y (- 1)) 
 (* |honda_test_fun_#t~malloc0.offset| 0) 
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset (- 1)) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 1) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| (- 1)) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 1)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 1) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 1) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset (- 1)) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 (- 1))
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 1) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 1)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| (- 1))
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base (- 1)) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 1)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| (- 1))
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 1)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 1) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y (- 1)) 
 (* |honda_test_fun_#t~malloc0.offset| 0) 
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 1)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x (- 1)) 
 (* |honda_test_fun_#t~malloc0.base| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 1) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 1) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 1) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset (- 1)) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 1) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset (- 1)) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 1)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 1) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| (- 1))
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 1) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset (- 1)) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 1) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| (- 1))
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0))
 (and
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 1) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| (- 1)) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 1)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| (- 1)) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| (- 1)) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 1) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y (- 1)) 
 (* |honda_test_fun_#t~malloc0.offset| 0) 
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base (- 1)) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 1) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset (- 1)) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 1) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| (- 1)) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 1)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 1) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 1) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset (- 1)) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 (- 1))
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 1) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 1) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0)
 (* honda_test_fun_~x_ref~2.base (- 1)) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 1)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| (- 1))
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 1)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| (- 1))
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 1)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 1) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y (- 1)) 
 (* |honda_test_fun_#t~malloc0.offset| 0) 
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 1)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x (- 1)) 
 (* |honda_test_fun_#t~malloc0.base| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 1) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 1) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 1) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset (- 1)) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 1) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset (- 1)) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 1)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 1) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| (- 1))
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 1) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset (- 1)) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 1) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| (- 1))
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0))
 (and
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 1) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| (- 1)) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 1)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 1) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0)
 (* honda_test_fun_~x_ref~2.base (- 1)) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| (- 1)) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 1) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| (- 1)) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 1) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y (- 1)) 
 (* |honda_test_fun_#t~malloc0.offset| 0) 
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset (- 1)) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 1) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| (- 1)) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 1)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 1) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 1) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset (- 1)) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 (- 1))
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 1) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 1)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| (- 1))
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 1)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| (- 1))
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 1)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 1) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y (- 1)) 
 (* |honda_test_fun_#t~malloc0.offset| 0) 
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 1)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x (- 1)) 
 (* |honda_test_fun_#t~malloc0.base| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 1) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 1) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 1) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset (- 1)) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 1) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset (- 1)) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 1) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base (- 1)) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 1)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 1) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| (- 1))
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 1) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset (- 1)) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 1) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| (- 1))
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0))
 (and
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 1) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| (- 1)) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 1)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| (- 1)) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| (- 1)) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 1) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y (- 1)) 
 (* |honda_test_fun_#t~malloc0.offset| 0) 
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset (- 1)) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 1) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| (- 1)) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 1)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 1) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 1) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset (- 1)) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 (- 1))
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 1) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 1)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| (- 1))
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base (- 1)) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 1)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| (- 1))
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 1)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 1) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y (- 1)) 
 (* |honda_test_fun_#t~malloc0.offset| 0) 
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 1)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x (- 1)) 
 (* |honda_test_fun_#t~malloc0.base| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 1) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 1) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 1) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset (- 1)) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 1) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset (- 1)) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base (- 1)) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 1) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 1)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 1) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 1) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| (- 1))
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 1) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset (- 1)) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 1) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| (- 1))
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0))
 (and
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 1) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| (- 1)) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 1)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| (- 1)) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| (- 1)) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 1) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y (- 1)) 
 (* |honda_test_fun_#t~malloc0.offset| 0) 
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset (- 1)) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 1) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| (- 1)) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 1)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 1) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 1) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset (- 1)) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 (- 1))
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 1) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0)
 (* honda_test_fun_~x_ref~2.base (- 1)) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 1)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| (- 1))
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 1)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| (- 1))
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 1)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 1) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y (- 1)) 
 (* |honda_test_fun_#t~malloc0.offset| 0) 
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 1)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base (- 1)) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 1) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x (- 1)) 
 (* |honda_test_fun_#t~malloc0.base| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 1) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 1) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 1) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset (- 1)) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 1) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset (- 1)) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 1)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 1) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 1) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| (- 1))
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 1) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset (- 1)) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 1) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| (- 1))
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0))
 (and
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 1) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| (- 1)) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 1)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| (- 1)) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 1) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| (- 1)) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 1) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y (- 1)) 
 (* |honda_test_fun_#t~malloc0.offset| 0) 
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset (- 1)) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 1) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| (- 1)) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 1)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 1) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 1) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset (- 1)) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 (- 1))
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 1) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 1)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| (- 1))
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base (- 1)) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 1)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| (- 1))
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 1)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 1) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y (- 1)) 
 (* |honda_test_fun_#t~malloc0.offset| 0) 
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 1)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x (- 1)) 
 (* |honda_test_fun_#t~malloc0.base| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 1) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 1) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 1) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset (- 1)) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 1) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset (- 1)) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 1) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base (- 1)) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 1)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 1) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| (- 1))
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 1) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset (- 1)) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 1) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| (- 1))
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0))
 (and
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 1) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| (- 1)) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 1)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| (- 1)) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| (- 1)) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 1) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y (- 1)) 
 (* |honda_test_fun_#t~malloc0.offset| 0) 
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset (- 1)) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 1) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| (- 1)) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 1)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 1) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 1) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset (- 1)) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 (- 1))
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 1) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 1)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| (- 1))
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 1)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| (- 1))
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 1)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 1) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y (- 1)) 
 (* |honda_test_fun_#t~malloc0.offset| 0) 
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 1)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x (- 1)) 
 (* |honda_test_fun_#t~malloc0.base| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 1) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 1) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 1) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset (- 1)) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 1) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset (- 1)) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base (- 1)) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 1) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 1)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 1) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 1) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| (- 1))
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 1) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 1) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0)
 (* honda_test_fun_~x_ref~2.base (- 1)) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset (- 1)) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 1) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| (- 1))
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0))
 (and
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 1) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| (- 1)) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 1)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| (- 1)) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| (- 1)) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 1) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y (- 1)) 
 (* |honda_test_fun_#t~malloc0.offset| 0) 
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset (- 1)) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 1) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| (- 1)) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 1)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 1) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 1) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset (- 1)) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 (- 1))
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 1) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0)
 (* honda_test_fun_~x_ref~2.base (- 1)) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 1)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| (- 1))
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 1)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| (- 1))
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 1)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 1) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y (- 1)) 
 (* |honda_test_fun_#t~malloc0.offset| 0) 
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 1)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x (- 1)) 
 (* |honda_test_fun_#t~malloc0.base| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 1) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 1) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 1) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset (- 1)) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 1) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset (- 1)) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 1) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base (- 1)) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 1)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 1) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 1) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| (- 1))
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 1) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset (- 1)) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 1) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| (- 1))
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0))
 (and
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 1) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| (- 1)) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 1)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| (- 1)) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| (- 1)) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 1) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y (- 1)) 
 (* |honda_test_fun_#t~malloc0.offset| 0) 
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base (- 1)) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 1) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset (- 1)) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 1) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| (- 1)) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 1)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 1) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 1) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset (- 1)) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 (- 1))
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 1) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0)
 (* honda_test_fun_~x_ref~2.base (- 1)) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 1)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| (- 1))
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 1)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| (- 1))
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 1)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 1) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y (- 1)) 
 (* |honda_test_fun_#t~malloc0.offset| 0) 
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 1)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x (- 1)) 
 (* |honda_test_fun_#t~malloc0.base| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 1) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 1) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 1) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset (- 1)) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 1) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset (- 1)) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base (- 1)) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 1) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 1)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 1) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| (- 1))
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 1) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset (- 1)) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 1) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| (- 1))
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0))
 (and
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 1) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| (- 1)) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 1)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| (- 1)) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| (- 1)) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 1) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y (- 1)) 
 (* |honda_test_fun_#t~malloc0.offset| 0) 
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset (- 1)) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 1) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| (- 1)) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 1)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 1) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 1) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset (- 1)) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 (- 1))
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 1) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 1) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0)
 (* honda_test_fun_~x_ref~2.base (- 1)) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 1)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| (- 1))
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 1)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| (- 1))
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 1)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 1) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y (- 1)) 
 (* |honda_test_fun_#t~malloc0.offset| 0) 
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 1)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x (- 1)) 
 (* |honda_test_fun_#t~malloc0.base| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 1) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 1) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 1) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset (- 1)) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 1) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset (- 1)) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base (- 1)) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 1) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 1)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 1) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| (- 1))
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 1) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset (- 1)) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 1) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| (- 1))
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0))
 (and
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 1) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| (- 1)) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 1)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| (- 1)) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 1) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| (- 1)) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 1) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y (- 1)) 
 (* |honda_test_fun_#t~malloc0.offset| 0) 
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base (- 1)) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 1) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset (- 1)) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 1) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| (- 1)) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 1)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 1) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 1) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset (- 1)) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 (- 1))
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 1) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 1)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| (- 1))
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 1)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| (- 1))
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 1)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 1) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y (- 1)) 
 (* |honda_test_fun_#t~malloc0.offset| 0) 
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 1)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x (- 1)) 
 (* |honda_test_fun_#t~malloc0.base| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 1) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base (- 1)) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 1) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 1) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset (- 1)) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 1) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset (- 1)) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 1)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 1) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| (- 1))
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 1) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset (- 1)) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 1) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| (- 1))
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0))
 (and
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 1) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| (- 1)) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 1)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 1) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0)
 (* honda_test_fun_~x_ref~2.base (- 1)) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| (- 1)) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| (- 1)) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 1) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y (- 1)) 
 (* |honda_test_fun_#t~malloc0.offset| 0) 
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset (- 1)) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 1) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| (- 1)) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 1)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 1) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 1) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset (- 1)) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 (- 1))
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 1) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 1)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| (- 1))
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 1)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| (- 1))
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 1)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 1) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y (- 1)) 
 (* |honda_test_fun_#t~malloc0.offset| 0) 
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 1)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base (- 1)) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 1) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x (- 1)) 
 (* |honda_test_fun_#t~malloc0.base| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 1) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base (- 1)) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 1) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 1) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset (- 1)) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 1) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset (- 1)) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 1)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 1) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| (- 1))
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 1) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset (- 1)) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 1) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| (- 1))
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0))
 (and
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 1) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| (- 1)) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 1)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| (- 1)) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| (- 1)) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 1) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y (- 1)) 
 (* |honda_test_fun_#t~malloc0.offset| 0) 
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base (- 1)) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 1) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset (- 1)) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 1) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| (- 1)) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 1)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 1) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 1) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset (- 1)) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 (- 1))
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 1) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 1) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 1)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| (- 1))
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 1)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| (- 1))
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 1)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 1) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y (- 1)) 
 (* |honda_test_fun_#t~malloc0.offset| 0) 
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 1)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x (- 1)) 
 (* |honda_test_fun_#t~malloc0.base| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 1) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 1) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 1) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset (- 1)) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 1) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset (- 1)) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base (- 1)) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 1) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 1)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 1) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| (- 1))
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 1) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset (- 1)) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 1) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| (- 1))
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0))
 (and
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 1) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| (- 1)) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 1)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| (- 1)) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| (- 1)) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 1) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y (- 1)) 
 (* |honda_test_fun_#t~malloc0.offset| 0) 
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base (- 1)) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 1) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset (- 1)) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 1) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| (- 1)) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 1)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 1) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 1) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset (- 1)) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 (- 1))
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 1) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 1)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| (- 1))
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 1)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| (- 1))
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 1)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 1) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y (- 1)) 
 (* |honda_test_fun_#t~malloc0.offset| 0) 
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 1)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x (- 1)) 
 (* |honda_test_fun_#t~malloc0.base| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 1) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base (- 1)) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 1) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 1) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset (- 1)) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 1) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset (- 1)) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 1)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 1) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| (- 1))
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 1) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 1) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0)
 (* honda_test_fun_~x_ref~2.base (- 1)) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset (- 1)) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 1) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| (- 1))
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0))
 (and
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 1) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| (- 1)) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 1)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| (- 1)) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 1) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| (- 1)) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 1) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y (- 1)) 
 (* |honda_test_fun_#t~malloc0.offset| 0) 
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset (- 1)) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 1) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| (- 1)) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 1)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 1) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 1) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset (- 1)) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 (- 1))
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 1) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 1)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| (- 1))
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 1)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| (- 1))
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 1)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 1) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y (- 1)) 
 (* |honda_test_fun_#t~malloc0.offset| 0) 
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 1)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x (- 1)) 
 (* |honda_test_fun_#t~malloc0.base| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 1) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base (- 1)) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 1) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 1) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset (- 1)) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 1) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset (- 1)) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 1)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 1) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| (- 1))
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 1) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 1) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0)
 (* honda_test_fun_~x_ref~2.base (- 1)) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset (- 1)) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 1) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| (- 1))
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0))
 (and
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 1) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| (- 1)) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 1)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| (- 1)) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| (- 1)) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 1) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y (- 1)) 
 (* |honda_test_fun_#t~malloc0.offset| 0) 
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset (- 1)) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 1) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| (- 1)) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 1)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 1) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 1) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset (- 1)) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 (- 1))
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 1) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 1) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 1)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| (- 1))
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 1)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| (- 1))
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 1)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 1) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y (- 1)) 
 (* |honda_test_fun_#t~malloc0.offset| 0) 
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 1)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base (- 1)) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 1) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x (- 1)) 
 (* |honda_test_fun_#t~malloc0.base| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 1) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base (- 1)) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 1) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 1) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset (- 1)) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 1) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset (- 1)) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 1)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 1) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| (- 1))
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 1) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset (- 1)) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 1) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| (- 1))
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0))
 (and
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 1) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| (- 1)) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 1)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| (- 1)) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| (- 1)) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 1) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y (- 1)) 
 (* |honda_test_fun_#t~malloc0.offset| 0) 
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset (- 1)) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 1) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| (- 1)) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 1)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 1) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 1) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset (- 1)) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 (- 1))
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 1) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 1)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| (- 1))
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 1)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| (- 1))
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 1)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 1) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y (- 1)) 
 (* |honda_test_fun_#t~malloc0.offset| 0) 
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 1)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base (- 1)) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 1) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x (- 1)) 
 (* |honda_test_fun_#t~malloc0.base| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 1) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 1) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 1) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset (- 1)) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 1) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset (- 1)) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 1) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base (- 1)) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 1)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 1) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 1) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| (- 1))
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 1) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset (- 1)) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 1) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| (- 1))
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0))
 (and
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 1) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| (- 1)) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 1)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| (- 1)) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| (- 1)) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 1) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y (- 1)) 
 (* |honda_test_fun_#t~malloc0.offset| 0) 
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset (- 1)) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 1) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| (- 1)) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 1)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 1) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 1) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset (- 1)) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 (- 1))
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 1) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 1)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| (- 1))
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base (- 1)) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 1)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| (- 1))
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 1)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 1) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y (- 1)) 
 (* |honda_test_fun_#t~malloc0.offset| 0) 
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 1)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x (- 1)) 
 (* |honda_test_fun_#t~malloc0.base| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 1) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 1) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 1) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset (- 1)) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 1) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset (- 1)) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base (- 1)) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 1) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 1)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 1) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| (- 1))
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 1) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 1) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0)
 (* honda_test_fun_~x_ref~2.base (- 1)) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset (- 1)) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 1) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| (- 1))
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0))
 (and
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 1) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| (- 1)) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 1)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 1) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0)
 (* honda_test_fun_~x_ref~2.base (- 1)) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| (- 1)) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| (- 1)) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 1) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y (- 1)) 
 (* |honda_test_fun_#t~malloc0.offset| 0) 
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset (- 1)) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 1) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| (- 1)) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 1)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 1) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 1) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset (- 1)) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 (- 1))
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 1) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 1) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 1)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| (- 1))
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 1)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| (- 1))
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 1)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 1) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y (- 1)) 
 (* |honda_test_fun_#t~malloc0.offset| 0) 
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 1)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base (- 1)) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 1) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x (- 1)) 
 (* |honda_test_fun_#t~malloc0.base| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 1) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 1) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 1) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset (- 1)) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 1) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset (- 1)) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 1)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 1) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| (- 1))
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 1) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset (- 1)) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 1) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| (- 1))
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0))
 (and
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 1) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| (- 1)) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 1)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| (- 1)) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| (- 1)) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 1) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y (- 1)) 
 (* |honda_test_fun_#t~malloc0.offset| 0) 
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset (- 1)) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 1) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| (- 1)) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 1)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 1) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 1) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset (- 1)) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 (- 1))
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 1) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 1)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| (- 1))
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base (- 1)) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 1)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| (- 1))
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 1)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 1) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y (- 1)) 
 (* |honda_test_fun_#t~malloc0.offset| 0) 
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 1)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x (- 1)) 
 (* |honda_test_fun_#t~malloc0.base| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 1) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 1) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 1) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset (- 1)) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 1) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset (- 1)) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 1)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 1) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 1) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| (- 1))
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 1) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 1) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0)
 (* honda_test_fun_~x_ref~2.base (- 1)) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset (- 1)) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 1) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| (- 1))
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0))
 (and
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 1) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| (- 1)) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 1)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| (- 1)) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 1) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| (- 1)) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 1) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y (- 1)) 
 (* |honda_test_fun_#t~malloc0.offset| 0) 
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base (- 1)) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 1) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset (- 1)) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 1) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| (- 1)) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 1)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 1) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 1) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset (- 1)) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 (- 1))
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 1) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 1)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| (- 1))
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 1)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| (- 1))
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 1)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 1) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y (- 1)) 
 (* |honda_test_fun_#t~malloc0.offset| 0) 
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 1)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x (- 1)) 
 (* |honda_test_fun_#t~malloc0.base| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 1) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 1) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 1) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset (- 1)) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 1) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset (- 1)) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 1)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 1) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| (- 1))
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 1) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 1) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0)
 (* honda_test_fun_~x_ref~2.base (- 1)) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset (- 1)) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 1) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| (- 1))
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_test_fun_#t~malloc2.base| 0) 
 (* honda_test_fun_~c~2.base 0) 
 (* |honda_test_fun_#in~y| 0) 
 (* |honda_test_fun_#t~mem6| 0) 
 (* |honda_test_fun_#t~malloc1.base| 0)
 (* |honda_test_fun_#t~malloc2.offset| 0) 
 (* |honda_test_fun_#t~mem7| 0) 
 (* |honda_test_fun_#t~mem16| 0) 
 (* honda_test_fun_~y 0) (* |honda_test_fun_#t~malloc0.offset| 0)
 (* honda_test_fun_~y_ref~2.base 0) 
 (* honda_test_fun_~x 0) (* |honda_test_fun_#t~malloc0.base| 0)
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~malloc1.offset| 0) 
 (* honda_test_fun_~x_ref~2.base 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* honda_test_fun_~y_ref~2.offset 0) 
 (* |honda_test_fun_#t~mem15| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_test_fun_#in~x| 0) 
 (* |honda_test_fun_#t~mem13| 0) 
 (* honda_test_fun_~x_ref~2.offset 0) 
 (* honda_test_fun_~c~2.offset 0) 
 (* |honda_#NULL.base| 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_(select old(#length) test_fun_~y_ref~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~c~2.base)| 0)
 (* |honda_(select old(#length) test_fun_~x_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~y_ref~2.base)| 0)
 (* |honda_(select #length test_fun_~c~2.base)| 0)
 (* |honda_(select #length test_fun_~x_ref~2.base)| 0)
 (* |honda_(ite test_fun_#t~short8 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |init_test_fun_#t~malloc2.base| 0) 
 (* init_test_fun_~c~2.base 0) 
 (* |init_test_fun_#in~y| 0) 
 (* |init_test_fun_#t~mem6| 0) 
 (* |init_test_fun_#t~malloc1.base| 0)
 (* |init_test_fun_#t~malloc2.offset| 0) 
 (* |init_test_fun_#t~mem7| 0) 
 (* |init_test_fun_#t~mem16| 0) 
 (* init_test_fun_~y 0) (* |init_test_fun_#t~malloc0.offset| 0)
 (* init_test_fun_~y_ref~2.base 0) 
 (* init_test_fun_~x 0) (* |init_test_fun_#t~malloc0.base| 0)
 (* |init_test_fun_#t~mem18| 0) 
 (* |init_test_fun_#t~malloc1.offset| 0) 
 (* init_test_fun_~x_ref~2.base 0) 
 (* |init_test_fun_#t~mem11| 0) 
 (* init_test_fun_~y_ref~2.offset 0) 
 (* |init_test_fun_#t~mem15| 0) 
 (* |init_test_fun_#t~mem12| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_test_fun_#in~x| 0) 
 (* |init_test_fun_#t~mem13| 0) 
 (* init_test_fun_~x_ref~2.offset 0) 
 (* init_test_fun_~c~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite test_fun_#t~short8 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)))
 (or
 (and
 (= |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|))
 (= |honda_test_fun_#t~malloc2.base|
 (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|))
 (= honda_test_fun_~c~2.base
 (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base))
 (= |honda_(select #length test_fun_~y_ref~2.base)|
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|))
 (=
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|))
 (= |honda_test_fun_#in~y| (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|))
 (= |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|))
 (= |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|))
 (= |honda_test_fun_#t~mem6|
 (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|))
 (= |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|))
 (= |honda_test_fun_#t~malloc1.base|
 (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|))
 (= |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|))
 (= |honda_test_fun_#t~malloc2.offset|
 (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|))
 (= |honda_test_fun_#t~mem7|
 (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= honda_test_fun_~y (+ honda_test_fun_~y ray_test_fun_~y))
 (= |honda_test_fun_#t~malloc0.offset|
 (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|))
 (= |honda_(select old(#length) test_fun_~c~2.base)|
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|))
 (=
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|))
 (= honda_test_fun_~y_ref~2.base
 (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base))
 (= honda_test_fun_~x (+ honda_test_fun_~x ray_test_fun_~x))
 (= |honda_(select #length test_fun_~c~2.base)|
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|))
 (= |honda_test_fun_#t~malloc0.base|
 (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|))
 (= |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|))
 (= |honda_test_fun_#t~malloc1.offset|
 (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|))
 (= |honda_(ite test_fun_#t~short8 1 0)|
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|))
 (= honda_test_fun_~x_ref~2.base
 (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base))
 (= honda_test_fun_~y_ref~2.offset
 (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_(select old(#length) test_fun_~x_ref~2.base)|
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|))
 (= |honda_test_fun_#t~mem15|
 (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|))
 (= |honda_(select #length test_fun_~x_ref~2.base)|
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|))
 (=
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= |honda_test_fun_#in~x| (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|))
 (= |honda_(select old(#length) test_fun_~y_ref~2.base)|
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|))
 (= honda_test_fun_~x_ref~2.offset
 (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset))
 (= honda_test_fun_~c~2.offset
 (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 (- 1))
 (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 1) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 1) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 (- 1)) (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 1)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) (- 1))
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 4)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) (- 1))
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 1)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 (- 1)) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 1) 1) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) (- 1))
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 1)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 (- 1))
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 1)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 1)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 (- 1))
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 1)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) (- 1))
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 4)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 1) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (- 1)) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 (- 1))
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 1) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 1)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| (- 1)) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 1) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) (- 1))
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 1)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) (- 1))
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 1)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 1) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 (- 1))
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) (- 1))
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 1)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 1)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 1)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 4)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 1)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) (- 1))
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 1)) 0)
 (= |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda))
 (= |ray_test_fun_#t~malloc2.base| (* |ray_test_fun_#t~malloc2.base| lambda))
 (= ray_test_fun_~c~2.base (* ray_test_fun_~c~2.base lambda))
 (= |ray_(select #length test_fun_~y_ref~2.base)|
 (* |ray_(select #length test_fun_~y_ref~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda)) (= |ray_test_fun_#in~y| (* |ray_test_fun_#in~y| lambda))
 (= |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|
 (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda))
 (= |ray_test_fun_#t~mem6| (* |ray_test_fun_#t~mem6| lambda))
 (= |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda))
 (= |ray_test_fun_#t~malloc1.base| (* |ray_test_fun_#t~malloc1.base| lambda))
 (= |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda))
 (= |ray_test_fun_#t~malloc2.offset|
 (* |ray_test_fun_#t~malloc2.offset| lambda))
 (= |ray_test_fun_#t~mem7| (* |ray_test_fun_#t~mem7| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= ray_test_fun_~y (* ray_test_fun_~y lambda))
 (= |ray_test_fun_#t~malloc0.offset|
 (* |ray_test_fun_#t~malloc0.offset| lambda))
 (= |ray_(select old(#length) test_fun_~c~2.base)|
 (* |ray_(select old(#length) test_fun_~c~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda))
 (= ray_test_fun_~y_ref~2.base (* ray_test_fun_~y_ref~2.base lambda))
 (= ray_test_fun_~x (* ray_test_fun_~x lambda))
 (= |ray_(select #length test_fun_~c~2.base)|
 (* |ray_(select #length test_fun_~c~2.base)| lambda))
 (= |ray_test_fun_#t~malloc0.base| (* |ray_test_fun_#t~malloc0.base| lambda))
 (= |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda))
 (= |ray_test_fun_#t~malloc1.offset|
 (* |ray_test_fun_#t~malloc1.offset| lambda))
 (= |ray_(ite test_fun_#t~short8 1 0)|
 (* |ray_(ite test_fun_#t~short8 1 0)| lambda))
 (= ray_test_fun_~x_ref~2.base (* ray_test_fun_~x_ref~2.base lambda))
 (= ray_test_fun_~y_ref~2.offset (* ray_test_fun_~y_ref~2.offset lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_(select old(#length) test_fun_~x_ref~2.base)|
 (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda))
 (= |ray_test_fun_#t~mem15| (* |ray_test_fun_#t~mem15| lambda))
 (= |ray_(select #length test_fun_~x_ref~2.base)|
 (* |ray_(select #length test_fun_~x_ref~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda)) (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= |ray_test_fun_#in~x| (* |ray_test_fun_#in~x| lambda))
 (= |ray_(select old(#length) test_fun_~y_ref~2.base)|
 (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda))
 (= ray_test_fun_~x_ref~2.offset (* ray_test_fun_~x_ref~2.offset lambda))
 (= ray_test_fun_~c~2.offset (* ray_test_fun_~c~2.offset lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) (- 1)) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 1) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 1) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 (- 1))) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 1)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) (- 1))
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) (- 1))
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 1)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) (- 1)) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 1)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) (- 1))
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 1)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) (- 1))
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) (- 1))
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 1)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) (- 1))
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 1)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) (- 1))
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (- 1)) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) (- 1))
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 1) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 1)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| (- 1)) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) (- 1))
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 1) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) (- 1))
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 1)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) (- 1))
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) (- 1))
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 1)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 1)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) (- 1))
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 1)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) (- 1))
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0) (= lambda lambda))
 (and
 (= |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|))
 (= |honda_test_fun_#t~malloc2.base|
 (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|))
 (= honda_test_fun_~c~2.base
 (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base))
 (= |honda_(select #length test_fun_~y_ref~2.base)|
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|))
 (=
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|))
 (= |honda_test_fun_#in~y| (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|))
 (= |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|))
 (= |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|))
 (= |honda_test_fun_#t~mem6|
 (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|))
 (= |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|))
 (= |honda_test_fun_#t~malloc1.base|
 (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|))
 (= |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|))
 (= |honda_test_fun_#t~malloc2.offset|
 (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|))
 (= |honda_test_fun_#t~mem7|
 (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= honda_test_fun_~y (+ honda_test_fun_~y ray_test_fun_~y))
 (= |honda_test_fun_#t~malloc0.offset|
 (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|))
 (= |honda_(select old(#length) test_fun_~c~2.base)|
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|))
 (=
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|))
 (= honda_test_fun_~y_ref~2.base
 (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base))
 (= honda_test_fun_~x (+ honda_test_fun_~x ray_test_fun_~x))
 (= |honda_(select #length test_fun_~c~2.base)|
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|))
 (= |honda_test_fun_#t~malloc0.base|
 (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|))
 (= |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|))
 (= |honda_test_fun_#t~malloc1.offset|
 (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|))
 (= |honda_(ite test_fun_#t~short8 1 0)|
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|))
 (= honda_test_fun_~x_ref~2.base
 (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base))
 (= honda_test_fun_~y_ref~2.offset
 (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_(select old(#length) test_fun_~x_ref~2.base)|
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|))
 (= |honda_test_fun_#t~mem15|
 (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|))
 (= |honda_(select #length test_fun_~x_ref~2.base)|
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|))
 (=
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= |honda_test_fun_#in~x| (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|))
 (= |honda_(select old(#length) test_fun_~y_ref~2.base)|
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|))
 (= honda_test_fun_~x_ref~2.offset
 (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset))
 (= honda_test_fun_~c~2.offset
 (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 (- 1))
 (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 1) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 1) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 (- 1)) (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 1)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) (- 1))
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 4)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) (- 1))
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 1)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 (- 1)) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 1) 1) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) (- 1))
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 1)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 (- 1))
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 1)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 1)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 (- 1))
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 1)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) (- 1))
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 4)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 1)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) (- 1))
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 1) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (- 1)) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 (- 1))
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 1) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 1)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| (- 1)) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 1) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) (- 1))
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 1)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) (- 1))
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 1)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 1) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 (- 1))
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 1)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) (- 1))
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 1)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 1)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 4)) 0)
 (= |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda))
 (= |ray_test_fun_#t~malloc2.base| (* |ray_test_fun_#t~malloc2.base| lambda))
 (= ray_test_fun_~c~2.base (* ray_test_fun_~c~2.base lambda))
 (= |ray_(select #length test_fun_~y_ref~2.base)|
 (* |ray_(select #length test_fun_~y_ref~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda)) (= |ray_test_fun_#in~y| (* |ray_test_fun_#in~y| lambda))
 (= |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|
 (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda))
 (= |ray_test_fun_#t~mem6| (* |ray_test_fun_#t~mem6| lambda))
 (= |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda))
 (= |ray_test_fun_#t~malloc1.base| (* |ray_test_fun_#t~malloc1.base| lambda))
 (= |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda))
 (= |ray_test_fun_#t~malloc2.offset|
 (* |ray_test_fun_#t~malloc2.offset| lambda))
 (= |ray_test_fun_#t~mem7| (* |ray_test_fun_#t~mem7| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= ray_test_fun_~y (* ray_test_fun_~y lambda))
 (= |ray_test_fun_#t~malloc0.offset|
 (* |ray_test_fun_#t~malloc0.offset| lambda))
 (= |ray_(select old(#length) test_fun_~c~2.base)|
 (* |ray_(select old(#length) test_fun_~c~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda))
 (= ray_test_fun_~y_ref~2.base (* ray_test_fun_~y_ref~2.base lambda))
 (= ray_test_fun_~x (* ray_test_fun_~x lambda))
 (= |ray_(select #length test_fun_~c~2.base)|
 (* |ray_(select #length test_fun_~c~2.base)| lambda))
 (= |ray_test_fun_#t~malloc0.base| (* |ray_test_fun_#t~malloc0.base| lambda))
 (= |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda))
 (= |ray_test_fun_#t~malloc1.offset|
 (* |ray_test_fun_#t~malloc1.offset| lambda))
 (= |ray_(ite test_fun_#t~short8 1 0)|
 (* |ray_(ite test_fun_#t~short8 1 0)| lambda))
 (= ray_test_fun_~x_ref~2.base (* ray_test_fun_~x_ref~2.base lambda))
 (= ray_test_fun_~y_ref~2.offset (* ray_test_fun_~y_ref~2.offset lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_(select old(#length) test_fun_~x_ref~2.base)|
 (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda))
 (= |ray_test_fun_#t~mem15| (* |ray_test_fun_#t~mem15| lambda))
 (= |ray_(select #length test_fun_~x_ref~2.base)|
 (* |ray_(select #length test_fun_~x_ref~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda)) (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= |ray_test_fun_#in~x| (* |ray_test_fun_#in~x| lambda))
 (= |ray_(select old(#length) test_fun_~y_ref~2.base)|
 (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda))
 (= ray_test_fun_~x_ref~2.offset (* ray_test_fun_~x_ref~2.offset lambda))
 (= ray_test_fun_~c~2.offset (* ray_test_fun_~c~2.offset lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) (- 1)) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 1) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 1) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 (- 1))) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 1)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) (- 1))
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) (- 1))
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 1)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) (- 1)) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 1)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) (- 1))
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 1)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) (- 1))
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) (- 1))
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 1)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) (- 1))
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 1)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) (- 1))
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 1)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) (- 1))
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (- 1)) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) (- 1))
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 1) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 1)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| (- 1)) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) (- 1))
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 1) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) (- 1))
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 1)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) (- 1))
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) (- 1))
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 1)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 1)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) (- 1))
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0) (= lambda lambda))
 (and
 (= |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|))
 (= |honda_test_fun_#t~malloc2.base|
 (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|))
 (= honda_test_fun_~c~2.base
 (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base))
 (= |honda_(select #length test_fun_~y_ref~2.base)|
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|))
 (=
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|))
 (= |honda_test_fun_#in~y| (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|))
 (= |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|))
 (= |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|))
 (= |honda_test_fun_#t~mem6|
 (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|))
 (= |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|))
 (= |honda_test_fun_#t~malloc1.base|
 (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|))
 (= |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|))
 (= |honda_test_fun_#t~malloc2.offset|
 (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|))
 (= |honda_test_fun_#t~mem7|
 (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= honda_test_fun_~y (+ honda_test_fun_~y ray_test_fun_~y))
 (= |honda_test_fun_#t~malloc0.offset|
 (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|))
 (= |honda_(select old(#length) test_fun_~c~2.base)|
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|))
 (=
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|))
 (= honda_test_fun_~y_ref~2.base
 (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base))
 (= honda_test_fun_~x (+ honda_test_fun_~x ray_test_fun_~x))
 (= |honda_(select #length test_fun_~c~2.base)|
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|))
 (= |honda_test_fun_#t~malloc0.base|
 (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|))
 (= |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|))
 (= |honda_test_fun_#t~malloc1.offset|
 (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|))
 (= |honda_(ite test_fun_#t~short8 1 0)|
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|))
 (= honda_test_fun_~x_ref~2.base
 (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base))
 (= honda_test_fun_~y_ref~2.offset
 (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_(select old(#length) test_fun_~x_ref~2.base)|
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|))
 (= |honda_test_fun_#t~mem15|
 (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|))
 (= |honda_(select #length test_fun_~x_ref~2.base)|
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|))
 (=
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= |honda_test_fun_#in~x| (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|))
 (= |honda_(select old(#length) test_fun_~y_ref~2.base)|
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|))
 (= honda_test_fun_~x_ref~2.offset
 (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset))
 (= honda_test_fun_~c~2.offset
 (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 (- 1))
 (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 1) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 1) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 (- 1)) (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 1)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) (- 1))
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 4)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) (- 1))
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 1)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 (- 1)) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 1) 1) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) (- 1))
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 1)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 (- 1))
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 1)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 1)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 1)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) (- 1))
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 4)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 1)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 1) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (- 1)) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 (- 1))
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 1) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 1)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| (- 1)) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 1) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) (- 1))
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 1)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) (- 1))
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 1)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 1) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 (- 1))
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) (- 1))
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 1)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 1)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 1)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 4)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 1)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) (- 1))
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 1)) 0)
 (= |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda))
 (= |ray_test_fun_#t~malloc2.base| (* |ray_test_fun_#t~malloc2.base| lambda))
 (= ray_test_fun_~c~2.base (* ray_test_fun_~c~2.base lambda))
 (= |ray_(select #length test_fun_~y_ref~2.base)|
 (* |ray_(select #length test_fun_~y_ref~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda)) (= |ray_test_fun_#in~y| (* |ray_test_fun_#in~y| lambda))
 (= |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|
 (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda))
 (= |ray_test_fun_#t~mem6| (* |ray_test_fun_#t~mem6| lambda))
 (= |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda))
 (= |ray_test_fun_#t~malloc1.base| (* |ray_test_fun_#t~malloc1.base| lambda))
 (= |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda))
 (= |ray_test_fun_#t~malloc2.offset|
 (* |ray_test_fun_#t~malloc2.offset| lambda))
 (= |ray_test_fun_#t~mem7| (* |ray_test_fun_#t~mem7| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= ray_test_fun_~y (* ray_test_fun_~y lambda))
 (= |ray_test_fun_#t~malloc0.offset|
 (* |ray_test_fun_#t~malloc0.offset| lambda))
 (= |ray_(select old(#length) test_fun_~c~2.base)|
 (* |ray_(select old(#length) test_fun_~c~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda))
 (= ray_test_fun_~y_ref~2.base (* ray_test_fun_~y_ref~2.base lambda))
 (= ray_test_fun_~x (* ray_test_fun_~x lambda))
 (= |ray_(select #length test_fun_~c~2.base)|
 (* |ray_(select #length test_fun_~c~2.base)| lambda))
 (= |ray_test_fun_#t~malloc0.base| (* |ray_test_fun_#t~malloc0.base| lambda))
 (= |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda))
 (= |ray_test_fun_#t~malloc1.offset|
 (* |ray_test_fun_#t~malloc1.offset| lambda))
 (= |ray_(ite test_fun_#t~short8 1 0)|
 (* |ray_(ite test_fun_#t~short8 1 0)| lambda))
 (= ray_test_fun_~x_ref~2.base (* ray_test_fun_~x_ref~2.base lambda))
 (= ray_test_fun_~y_ref~2.offset (* ray_test_fun_~y_ref~2.offset lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_(select old(#length) test_fun_~x_ref~2.base)|
 (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda))
 (= |ray_test_fun_#t~mem15| (* |ray_test_fun_#t~mem15| lambda))
 (= |ray_(select #length test_fun_~x_ref~2.base)|
 (* |ray_(select #length test_fun_~x_ref~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda)) (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= |ray_test_fun_#in~x| (* |ray_test_fun_#in~x| lambda))
 (= |ray_(select old(#length) test_fun_~y_ref~2.base)|
 (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda))
 (= ray_test_fun_~x_ref~2.offset (* ray_test_fun_~x_ref~2.offset lambda))
 (= ray_test_fun_~c~2.offset (* ray_test_fun_~c~2.offset lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) (- 1)) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 1) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 1) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 (- 1))) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 1)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) (- 1))
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) (- 1))
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 1)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) (- 1)) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 1)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) (- 1))
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 1)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) (- 1))
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) (- 1))
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 1)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 1)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) (- 1))
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 1)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (- 1)) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) (- 1))
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 1) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 1)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| (- 1)) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) (- 1))
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 1) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) (- 1))
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 1)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) (- 1))
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) (- 1))
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 1)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 1)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) (- 1))
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 1)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) (- 1))
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0) (= lambda lambda))
 (and
 (= |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|))
 (= |honda_test_fun_#t~malloc2.base|
 (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|))
 (= honda_test_fun_~c~2.base
 (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base))
 (= |honda_(select #length test_fun_~y_ref~2.base)|
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|))
 (=
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|))
 (= |honda_test_fun_#in~y| (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|))
 (= |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|))
 (= |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|))
 (= |honda_test_fun_#t~mem6|
 (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|))
 (= |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|))
 (= |honda_test_fun_#t~malloc1.base|
 (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|))
 (= |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|))
 (= |honda_test_fun_#t~malloc2.offset|
 (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|))
 (= |honda_test_fun_#t~mem7|
 (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= honda_test_fun_~y (+ honda_test_fun_~y ray_test_fun_~y))
 (= |honda_test_fun_#t~malloc0.offset|
 (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|))
 (= |honda_(select old(#length) test_fun_~c~2.base)|
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|))
 (=
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|))
 (= honda_test_fun_~y_ref~2.base
 (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base))
 (= honda_test_fun_~x (+ honda_test_fun_~x ray_test_fun_~x))
 (= |honda_(select #length test_fun_~c~2.base)|
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|))
 (= |honda_test_fun_#t~malloc0.base|
 (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|))
 (= |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|))
 (= |honda_test_fun_#t~malloc1.offset|
 (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|))
 (= |honda_(ite test_fun_#t~short8 1 0)|
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|))
 (= honda_test_fun_~x_ref~2.base
 (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base))
 (= honda_test_fun_~y_ref~2.offset
 (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_(select old(#length) test_fun_~x_ref~2.base)|
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|))
 (= |honda_test_fun_#t~mem15|
 (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|))
 (= |honda_(select #length test_fun_~x_ref~2.base)|
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|))
 (=
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= |honda_test_fun_#in~x| (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|))
 (= |honda_(select old(#length) test_fun_~y_ref~2.base)|
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|))
 (= honda_test_fun_~x_ref~2.offset
 (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset))
 (= honda_test_fun_~c~2.offset
 (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 (- 1))
 (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 1) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 1) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 (- 1)) (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 1)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) (- 1))
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 4)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) (- 1))
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 1)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 (- 1)) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 1) 1) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) (- 1))
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 1)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 (- 1))
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 1)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 1)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 1)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) (- 1))
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 4)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 1)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 1) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (- 1)) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) (- 1))
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 1)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 (- 1))
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 1) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 1)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| (- 1)) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 1) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) (- 1))
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 1)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) (- 1))
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 1)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 1) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 (- 1))
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 1)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 1)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 4)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 1)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) (- 1))
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 1)) 0)
 (= |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda))
 (= |ray_test_fun_#t~malloc2.base| (* |ray_test_fun_#t~malloc2.base| lambda))
 (= ray_test_fun_~c~2.base (* ray_test_fun_~c~2.base lambda))
 (= |ray_(select #length test_fun_~y_ref~2.base)|
 (* |ray_(select #length test_fun_~y_ref~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda)) (= |ray_test_fun_#in~y| (* |ray_test_fun_#in~y| lambda))
 (= |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|
 (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda))
 (= |ray_test_fun_#t~mem6| (* |ray_test_fun_#t~mem6| lambda))
 (= |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda))
 (= |ray_test_fun_#t~malloc1.base| (* |ray_test_fun_#t~malloc1.base| lambda))
 (= |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda))
 (= |ray_test_fun_#t~malloc2.offset|
 (* |ray_test_fun_#t~malloc2.offset| lambda))
 (= |ray_test_fun_#t~mem7| (* |ray_test_fun_#t~mem7| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= ray_test_fun_~y (* ray_test_fun_~y lambda))
 (= |ray_test_fun_#t~malloc0.offset|
 (* |ray_test_fun_#t~malloc0.offset| lambda))
 (= |ray_(select old(#length) test_fun_~c~2.base)|
 (* |ray_(select old(#length) test_fun_~c~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda))
 (= ray_test_fun_~y_ref~2.base (* ray_test_fun_~y_ref~2.base lambda))
 (= ray_test_fun_~x (* ray_test_fun_~x lambda))
 (= |ray_(select #length test_fun_~c~2.base)|
 (* |ray_(select #length test_fun_~c~2.base)| lambda))
 (= |ray_test_fun_#t~malloc0.base| (* |ray_test_fun_#t~malloc0.base| lambda))
 (= |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda))
 (= |ray_test_fun_#t~malloc1.offset|
 (* |ray_test_fun_#t~malloc1.offset| lambda))
 (= |ray_(ite test_fun_#t~short8 1 0)|
 (* |ray_(ite test_fun_#t~short8 1 0)| lambda))
 (= ray_test_fun_~x_ref~2.base (* ray_test_fun_~x_ref~2.base lambda))
 (= ray_test_fun_~y_ref~2.offset (* ray_test_fun_~y_ref~2.offset lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_(select old(#length) test_fun_~x_ref~2.base)|
 (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda))
 (= |ray_test_fun_#t~mem15| (* |ray_test_fun_#t~mem15| lambda))
 (= |ray_(select #length test_fun_~x_ref~2.base)|
 (* |ray_(select #length test_fun_~x_ref~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda)) (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= |ray_test_fun_#in~x| (* |ray_test_fun_#in~x| lambda))
 (= |ray_(select old(#length) test_fun_~y_ref~2.base)|
 (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda))
 (= ray_test_fun_~x_ref~2.offset (* ray_test_fun_~x_ref~2.offset lambda))
 (= ray_test_fun_~c~2.offset (* ray_test_fun_~c~2.offset lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) (- 1)) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 1) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 1) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 (- 1))) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 1)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) (- 1))
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) (- 1))
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 1)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) (- 1)) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 1)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) (- 1))
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 1)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) (- 1))
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) (- 1))
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 1)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 1)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) (- 1))
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 1)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (- 1)) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) (- 1))
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 1)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) (- 1))
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 1) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 1)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| (- 1)) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) (- 1))
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 1) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) (- 1))
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 1)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) (- 1))
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 1)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) (- 1))
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 1)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) (- 1))
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0) (= lambda lambda))
 (and
 (= |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|))
 (= |honda_test_fun_#t~malloc2.base|
 (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|))
 (= honda_test_fun_~c~2.base
 (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base))
 (= |honda_(select #length test_fun_~y_ref~2.base)|
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|))
 (=
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|))
 (= |honda_test_fun_#in~y| (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|))
 (= |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|))
 (= |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|))
 (= |honda_test_fun_#t~mem6|
 (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|))
 (= |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|))
 (= |honda_test_fun_#t~malloc1.base|
 (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|))
 (= |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|))
 (= |honda_test_fun_#t~malloc2.offset|
 (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|))
 (= |honda_test_fun_#t~mem7|
 (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= honda_test_fun_~y (+ honda_test_fun_~y ray_test_fun_~y))
 (= |honda_test_fun_#t~malloc0.offset|
 (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|))
 (= |honda_(select old(#length) test_fun_~c~2.base)|
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|))
 (=
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|))
 (= honda_test_fun_~y_ref~2.base
 (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base))
 (= honda_test_fun_~x (+ honda_test_fun_~x ray_test_fun_~x))
 (= |honda_(select #length test_fun_~c~2.base)|
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|))
 (= |honda_test_fun_#t~malloc0.base|
 (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|))
 (= |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|))
 (= |honda_test_fun_#t~malloc1.offset|
 (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|))
 (= |honda_(ite test_fun_#t~short8 1 0)|
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|))
 (= honda_test_fun_~x_ref~2.base
 (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base))
 (= honda_test_fun_~y_ref~2.offset
 (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_(select old(#length) test_fun_~x_ref~2.base)|
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|))
 (= |honda_test_fun_#t~mem15|
 (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|))
 (= |honda_(select #length test_fun_~x_ref~2.base)|
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|))
 (=
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= |honda_test_fun_#in~x| (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|))
 (= |honda_(select old(#length) test_fun_~y_ref~2.base)|
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|))
 (= honda_test_fun_~x_ref~2.offset
 (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset))
 (= honda_test_fun_~c~2.offset
 (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 (- 1))
 (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 1) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 1) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 (- 1)) (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 1)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) (- 1))
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 4)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) (- 1))
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 1)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 (- 1)) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 1) 1) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) (- 1))
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 1)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 (- 1))
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 1)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 1)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 (- 1))
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 1)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) (- 1))
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 4)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 1) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (- 1)) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 (- 1))
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 1) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 1)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| (- 1)) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 1) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) (- 1))
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 1)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) (- 1))
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 1)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 1) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 (- 1))
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 1)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) (- 1))
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 1)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) (- 1))
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 1)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 1)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 4)) 0)
 (= |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda))
 (= |ray_test_fun_#t~malloc2.base| (* |ray_test_fun_#t~malloc2.base| lambda))
 (= ray_test_fun_~c~2.base (* ray_test_fun_~c~2.base lambda))
 (= |ray_(select #length test_fun_~y_ref~2.base)|
 (* |ray_(select #length test_fun_~y_ref~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda)) (= |ray_test_fun_#in~y| (* |ray_test_fun_#in~y| lambda))
 (= |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|
 (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda))
 (= |ray_test_fun_#t~mem6| (* |ray_test_fun_#t~mem6| lambda))
 (= |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda))
 (= |ray_test_fun_#t~malloc1.base| (* |ray_test_fun_#t~malloc1.base| lambda))
 (= |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda))
 (= |ray_test_fun_#t~malloc2.offset|
 (* |ray_test_fun_#t~malloc2.offset| lambda))
 (= |ray_test_fun_#t~mem7| (* |ray_test_fun_#t~mem7| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= ray_test_fun_~y (* ray_test_fun_~y lambda))
 (= |ray_test_fun_#t~malloc0.offset|
 (* |ray_test_fun_#t~malloc0.offset| lambda))
 (= |ray_(select old(#length) test_fun_~c~2.base)|
 (* |ray_(select old(#length) test_fun_~c~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda))
 (= ray_test_fun_~y_ref~2.base (* ray_test_fun_~y_ref~2.base lambda))
 (= ray_test_fun_~x (* ray_test_fun_~x lambda))
 (= |ray_(select #length test_fun_~c~2.base)|
 (* |ray_(select #length test_fun_~c~2.base)| lambda))
 (= |ray_test_fun_#t~malloc0.base| (* |ray_test_fun_#t~malloc0.base| lambda))
 (= |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda))
 (= |ray_test_fun_#t~malloc1.offset|
 (* |ray_test_fun_#t~malloc1.offset| lambda))
 (= |ray_(ite test_fun_#t~short8 1 0)|
 (* |ray_(ite test_fun_#t~short8 1 0)| lambda))
 (= ray_test_fun_~x_ref~2.base (* ray_test_fun_~x_ref~2.base lambda))
 (= ray_test_fun_~y_ref~2.offset (* ray_test_fun_~y_ref~2.offset lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_(select old(#length) test_fun_~x_ref~2.base)|
 (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda))
 (= |ray_test_fun_#t~mem15| (* |ray_test_fun_#t~mem15| lambda))
 (= |ray_(select #length test_fun_~x_ref~2.base)|
 (* |ray_(select #length test_fun_~x_ref~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda)) (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= |ray_test_fun_#in~x| (* |ray_test_fun_#in~x| lambda))
 (= |ray_(select old(#length) test_fun_~y_ref~2.base)|
 (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda))
 (= ray_test_fun_~x_ref~2.offset (* ray_test_fun_~x_ref~2.offset lambda))
 (= ray_test_fun_~c~2.offset (* ray_test_fun_~c~2.offset lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) (- 1)) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 1) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 1) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 (- 1))) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 1)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) (- 1))
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) (- 1))
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 1)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) (- 1)) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 1)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) (- 1))
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 1)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) (- 1))
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) (- 1))
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 1)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) (- 1))
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 1)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) (- 1))
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (- 1)) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) (- 1))
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 1) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 1)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| (- 1)) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) (- 1))
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 1) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) (- 1))
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 1)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) (- 1))
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 1)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) (- 1))
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) (- 1))
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 1)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 1)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) (- 1))
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0) (= lambda lambda))
 (and
 (= |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|))
 (= |honda_test_fun_#t~malloc2.base|
 (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|))
 (= honda_test_fun_~c~2.base
 (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base))
 (= |honda_(select #length test_fun_~y_ref~2.base)|
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|))
 (=
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|))
 (= |honda_test_fun_#in~y| (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|))
 (= |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|))
 (= |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|))
 (= |honda_test_fun_#t~mem6|
 (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|))
 (= |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|))
 (= |honda_test_fun_#t~malloc1.base|
 (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|))
 (= |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|))
 (= |honda_test_fun_#t~malloc2.offset|
 (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|))
 (= |honda_test_fun_#t~mem7|
 (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= honda_test_fun_~y (+ honda_test_fun_~y ray_test_fun_~y))
 (= |honda_test_fun_#t~malloc0.offset|
 (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|))
 (= |honda_(select old(#length) test_fun_~c~2.base)|
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|))
 (=
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|))
 (= honda_test_fun_~y_ref~2.base
 (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base))
 (= honda_test_fun_~x (+ honda_test_fun_~x ray_test_fun_~x))
 (= |honda_(select #length test_fun_~c~2.base)|
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|))
 (= |honda_test_fun_#t~malloc0.base|
 (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|))
 (= |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|))
 (= |honda_test_fun_#t~malloc1.offset|
 (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|))
 (= |honda_(ite test_fun_#t~short8 1 0)|
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|))
 (= honda_test_fun_~x_ref~2.base
 (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base))
 (= honda_test_fun_~y_ref~2.offset
 (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_(select old(#length) test_fun_~x_ref~2.base)|
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|))
 (= |honda_test_fun_#t~mem15|
 (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|))
 (= |honda_(select #length test_fun_~x_ref~2.base)|
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|))
 (=
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= |honda_test_fun_#in~x| (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|))
 (= |honda_(select old(#length) test_fun_~y_ref~2.base)|
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|))
 (= honda_test_fun_~x_ref~2.offset
 (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset))
 (= honda_test_fun_~c~2.offset
 (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 (- 1))
 (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 1) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 1) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 (- 1)) (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 1)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) (- 1))
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 4)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) (- 1))
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 1)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 (- 1)) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 1) 1) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) (- 1))
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 1)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 (- 1))
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 1)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 1)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 1)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) (- 1))
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 4)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 1)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 1) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (- 1)) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) (- 1))
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 1)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 (- 1))
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 1) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 1)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| (- 1)) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 1) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) (- 1))
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 1)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) (- 1))
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 1)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 1) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 (- 1))
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) (- 1))
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 1)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 1)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 1)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 4)) 0)
 (= |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda))
 (= |ray_test_fun_#t~malloc2.base| (* |ray_test_fun_#t~malloc2.base| lambda))
 (= ray_test_fun_~c~2.base (* ray_test_fun_~c~2.base lambda))
 (= |ray_(select #length test_fun_~y_ref~2.base)|
 (* |ray_(select #length test_fun_~y_ref~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda)) (= |ray_test_fun_#in~y| (* |ray_test_fun_#in~y| lambda))
 (= |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|
 (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda))
 (= |ray_test_fun_#t~mem6| (* |ray_test_fun_#t~mem6| lambda))
 (= |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda))
 (= |ray_test_fun_#t~malloc1.base| (* |ray_test_fun_#t~malloc1.base| lambda))
 (= |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda))
 (= |ray_test_fun_#t~malloc2.offset|
 (* |ray_test_fun_#t~malloc2.offset| lambda))
 (= |ray_test_fun_#t~mem7| (* |ray_test_fun_#t~mem7| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= ray_test_fun_~y (* ray_test_fun_~y lambda))
 (= |ray_test_fun_#t~malloc0.offset|
 (* |ray_test_fun_#t~malloc0.offset| lambda))
 (= |ray_(select old(#length) test_fun_~c~2.base)|
 (* |ray_(select old(#length) test_fun_~c~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda))
 (= ray_test_fun_~y_ref~2.base (* ray_test_fun_~y_ref~2.base lambda))
 (= ray_test_fun_~x (* ray_test_fun_~x lambda))
 (= |ray_(select #length test_fun_~c~2.base)|
 (* |ray_(select #length test_fun_~c~2.base)| lambda))
 (= |ray_test_fun_#t~malloc0.base| (* |ray_test_fun_#t~malloc0.base| lambda))
 (= |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda))
 (= |ray_test_fun_#t~malloc1.offset|
 (* |ray_test_fun_#t~malloc1.offset| lambda))
 (= |ray_(ite test_fun_#t~short8 1 0)|
 (* |ray_(ite test_fun_#t~short8 1 0)| lambda))
 (= ray_test_fun_~x_ref~2.base (* ray_test_fun_~x_ref~2.base lambda))
 (= ray_test_fun_~y_ref~2.offset (* ray_test_fun_~y_ref~2.offset lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_(select old(#length) test_fun_~x_ref~2.base)|
 (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda))
 (= |ray_test_fun_#t~mem15| (* |ray_test_fun_#t~mem15| lambda))
 (= |ray_(select #length test_fun_~x_ref~2.base)|
 (* |ray_(select #length test_fun_~x_ref~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda)) (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= |ray_test_fun_#in~x| (* |ray_test_fun_#in~x| lambda))
 (= |ray_(select old(#length) test_fun_~y_ref~2.base)|
 (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda))
 (= ray_test_fun_~x_ref~2.offset (* ray_test_fun_~x_ref~2.offset lambda))
 (= ray_test_fun_~c~2.offset (* ray_test_fun_~c~2.offset lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) (- 1)) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 1) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 1) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 (- 1))) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 1)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) (- 1))
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) (- 1))
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 1)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) (- 1)) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 1)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) (- 1))
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 1)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) (- 1))
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) (- 1))
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 1)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 1)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) (- 1))
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 1)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (- 1)) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) (- 1))
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 1)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) (- 1))
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 1) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 1)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| (- 1)) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) (- 1))
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 1) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) (- 1))
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 1)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) (- 1))
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) (- 1))
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 1)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 1)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) (- 1))
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0) (= lambda lambda))
 (and
 (= |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|))
 (= |honda_test_fun_#t~malloc2.base|
 (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|))
 (= honda_test_fun_~c~2.base
 (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base))
 (= |honda_(select #length test_fun_~y_ref~2.base)|
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|))
 (=
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|))
 (= |honda_test_fun_#in~y| (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|))
 (= |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|))
 (= |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|))
 (= |honda_test_fun_#t~mem6|
 (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|))
 (= |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|))
 (= |honda_test_fun_#t~malloc1.base|
 (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|))
 (= |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|))
 (= |honda_test_fun_#t~malloc2.offset|
 (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|))
 (= |honda_test_fun_#t~mem7|
 (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= honda_test_fun_~y (+ honda_test_fun_~y ray_test_fun_~y))
 (= |honda_test_fun_#t~malloc0.offset|
 (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|))
 (= |honda_(select old(#length) test_fun_~c~2.base)|
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|))
 (=
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|))
 (= honda_test_fun_~y_ref~2.base
 (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base))
 (= honda_test_fun_~x (+ honda_test_fun_~x ray_test_fun_~x))
 (= |honda_(select #length test_fun_~c~2.base)|
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|))
 (= |honda_test_fun_#t~malloc0.base|
 (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|))
 (= |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|))
 (= |honda_test_fun_#t~malloc1.offset|
 (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|))
 (= |honda_(ite test_fun_#t~short8 1 0)|
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|))
 (= honda_test_fun_~x_ref~2.base
 (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base))
 (= honda_test_fun_~y_ref~2.offset
 (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_(select old(#length) test_fun_~x_ref~2.base)|
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|))
 (= |honda_test_fun_#t~mem15|
 (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|))
 (= |honda_(select #length test_fun_~x_ref~2.base)|
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|))
 (=
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= |honda_test_fun_#in~x| (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|))
 (= |honda_(select old(#length) test_fun_~y_ref~2.base)|
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|))
 (= honda_test_fun_~x_ref~2.offset
 (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset))
 (= honda_test_fun_~c~2.offset
 (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 (- 1))
 (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 1) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 1) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 (- 1)) (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 1)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) (- 1))
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 4)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) (- 1))
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 1)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 (- 1)) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 1) 1) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) (- 1))
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 1)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 (- 1))
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 1)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 1)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 (- 1))
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 1)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) (- 1))
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 4)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 1) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (- 1)) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) (- 1))
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 1)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 (- 1))
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 1) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 1)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| (- 1)) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 1) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) (- 1))
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 1)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) (- 1))
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 1)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 1) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 (- 1))
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) (- 1))
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 1)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 1)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 1)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 4)) 0)
 (= |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda))
 (= |ray_test_fun_#t~malloc2.base| (* |ray_test_fun_#t~malloc2.base| lambda))
 (= ray_test_fun_~c~2.base (* ray_test_fun_~c~2.base lambda))
 (= |ray_(select #length test_fun_~y_ref~2.base)|
 (* |ray_(select #length test_fun_~y_ref~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda)) (= |ray_test_fun_#in~y| (* |ray_test_fun_#in~y| lambda))
 (= |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|
 (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda))
 (= |ray_test_fun_#t~mem6| (* |ray_test_fun_#t~mem6| lambda))
 (= |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda))
 (= |ray_test_fun_#t~malloc1.base| (* |ray_test_fun_#t~malloc1.base| lambda))
 (= |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda))
 (= |ray_test_fun_#t~malloc2.offset|
 (* |ray_test_fun_#t~malloc2.offset| lambda))
 (= |ray_test_fun_#t~mem7| (* |ray_test_fun_#t~mem7| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= ray_test_fun_~y (* ray_test_fun_~y lambda))
 (= |ray_test_fun_#t~malloc0.offset|
 (* |ray_test_fun_#t~malloc0.offset| lambda))
 (= |ray_(select old(#length) test_fun_~c~2.base)|
 (* |ray_(select old(#length) test_fun_~c~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda))
 (= ray_test_fun_~y_ref~2.base (* ray_test_fun_~y_ref~2.base lambda))
 (= ray_test_fun_~x (* ray_test_fun_~x lambda))
 (= |ray_(select #length test_fun_~c~2.base)|
 (* |ray_(select #length test_fun_~c~2.base)| lambda))
 (= |ray_test_fun_#t~malloc0.base| (* |ray_test_fun_#t~malloc0.base| lambda))
 (= |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda))
 (= |ray_test_fun_#t~malloc1.offset|
 (* |ray_test_fun_#t~malloc1.offset| lambda))
 (= |ray_(ite test_fun_#t~short8 1 0)|
 (* |ray_(ite test_fun_#t~short8 1 0)| lambda))
 (= ray_test_fun_~x_ref~2.base (* ray_test_fun_~x_ref~2.base lambda))
 (= ray_test_fun_~y_ref~2.offset (* ray_test_fun_~y_ref~2.offset lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_(select old(#length) test_fun_~x_ref~2.base)|
 (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda))
 (= |ray_test_fun_#t~mem15| (* |ray_test_fun_#t~mem15| lambda))
 (= |ray_(select #length test_fun_~x_ref~2.base)|
 (* |ray_(select #length test_fun_~x_ref~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda)) (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= |ray_test_fun_#in~x| (* |ray_test_fun_#in~x| lambda))
 (= |ray_(select old(#length) test_fun_~y_ref~2.base)|
 (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda))
 (= ray_test_fun_~x_ref~2.offset (* ray_test_fun_~x_ref~2.offset lambda))
 (= ray_test_fun_~c~2.offset (* ray_test_fun_~c~2.offset lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) (- 1)) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 1) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 1) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 (- 1))) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 1)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) (- 1))
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) (- 1))
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 1)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) (- 1)) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 1)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) (- 1))
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 1)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) (- 1))
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) (- 1))
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 1)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) (- 1))
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 1)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) (- 1))
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (- 1)) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) (- 1))
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 1)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) (- 1))
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 1) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 1)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| (- 1)) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) (- 1))
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 1) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) (- 1))
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 1)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) (- 1))
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) (- 1))
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 1)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 1)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) (- 1))
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0) (= lambda lambda))
 (and
 (= |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|))
 (= |honda_test_fun_#t~malloc2.base|
 (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|))
 (= honda_test_fun_~c~2.base
 (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base))
 (= |honda_(select #length test_fun_~y_ref~2.base)|
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|))
 (=
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|))
 (= |honda_test_fun_#in~y| (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|))
 (= |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|))
 (= |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|))
 (= |honda_test_fun_#t~mem6|
 (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|))
 (= |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|))
 (= |honda_test_fun_#t~malloc1.base|
 (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|))
 (= |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|))
 (= |honda_test_fun_#t~malloc2.offset|
 (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|))
 (= |honda_test_fun_#t~mem7|
 (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= honda_test_fun_~y (+ honda_test_fun_~y ray_test_fun_~y))
 (= |honda_test_fun_#t~malloc0.offset|
 (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|))
 (= |honda_(select old(#length) test_fun_~c~2.base)|
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|))
 (=
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|))
 (= honda_test_fun_~y_ref~2.base
 (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base))
 (= honda_test_fun_~x (+ honda_test_fun_~x ray_test_fun_~x))
 (= |honda_(select #length test_fun_~c~2.base)|
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|))
 (= |honda_test_fun_#t~malloc0.base|
 (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|))
 (= |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|))
 (= |honda_test_fun_#t~malloc1.offset|
 (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|))
 (= |honda_(ite test_fun_#t~short8 1 0)|
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|))
 (= honda_test_fun_~x_ref~2.base
 (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base))
 (= honda_test_fun_~y_ref~2.offset
 (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_(select old(#length) test_fun_~x_ref~2.base)|
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|))
 (= |honda_test_fun_#t~mem15|
 (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|))
 (= |honda_(select #length test_fun_~x_ref~2.base)|
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|))
 (=
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= |honda_test_fun_#in~x| (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|))
 (= |honda_(select old(#length) test_fun_~y_ref~2.base)|
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|))
 (= honda_test_fun_~x_ref~2.offset
 (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset))
 (= honda_test_fun_~c~2.offset
 (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 (- 1))
 (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 1) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 1) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 (- 1)) (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 1)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) (- 1))
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 4)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) (- 1))
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 1)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 (- 1)) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 1) 1) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) (- 1))
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 1)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 (- 1))
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 1)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 1)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 (- 1))
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 1)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) (- 1))
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 4)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 1)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) (- 1))
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 1) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (- 1)) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 (- 1))
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 1) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 1)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| (- 1)) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 1) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) (- 1))
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 1)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) (- 1))
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 1)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 1) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 (- 1))
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 1)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) (- 1))
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 1)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 1)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 4)) 0)
 (= |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda))
 (= |ray_test_fun_#t~malloc2.base| (* |ray_test_fun_#t~malloc2.base| lambda))
 (= ray_test_fun_~c~2.base (* ray_test_fun_~c~2.base lambda))
 (= |ray_(select #length test_fun_~y_ref~2.base)|
 (* |ray_(select #length test_fun_~y_ref~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda)) (= |ray_test_fun_#in~y| (* |ray_test_fun_#in~y| lambda))
 (= |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|
 (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda))
 (= |ray_test_fun_#t~mem6| (* |ray_test_fun_#t~mem6| lambda))
 (= |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda))
 (= |ray_test_fun_#t~malloc1.base| (* |ray_test_fun_#t~malloc1.base| lambda))
 (= |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda))
 (= |ray_test_fun_#t~malloc2.offset|
 (* |ray_test_fun_#t~malloc2.offset| lambda))
 (= |ray_test_fun_#t~mem7| (* |ray_test_fun_#t~mem7| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= ray_test_fun_~y (* ray_test_fun_~y lambda))
 (= |ray_test_fun_#t~malloc0.offset|
 (* |ray_test_fun_#t~malloc0.offset| lambda))
 (= |ray_(select old(#length) test_fun_~c~2.base)|
 (* |ray_(select old(#length) test_fun_~c~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda))
 (= ray_test_fun_~y_ref~2.base (* ray_test_fun_~y_ref~2.base lambda))
 (= ray_test_fun_~x (* ray_test_fun_~x lambda))
 (= |ray_(select #length test_fun_~c~2.base)|
 (* |ray_(select #length test_fun_~c~2.base)| lambda))
 (= |ray_test_fun_#t~malloc0.base| (* |ray_test_fun_#t~malloc0.base| lambda))
 (= |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda))
 (= |ray_test_fun_#t~malloc1.offset|
 (* |ray_test_fun_#t~malloc1.offset| lambda))
 (= |ray_(ite test_fun_#t~short8 1 0)|
 (* |ray_(ite test_fun_#t~short8 1 0)| lambda))
 (= ray_test_fun_~x_ref~2.base (* ray_test_fun_~x_ref~2.base lambda))
 (= ray_test_fun_~y_ref~2.offset (* ray_test_fun_~y_ref~2.offset lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_(select old(#length) test_fun_~x_ref~2.base)|
 (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda))
 (= |ray_test_fun_#t~mem15| (* |ray_test_fun_#t~mem15| lambda))
 (= |ray_(select #length test_fun_~x_ref~2.base)|
 (* |ray_(select #length test_fun_~x_ref~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda)) (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= |ray_test_fun_#in~x| (* |ray_test_fun_#in~x| lambda))
 (= |ray_(select old(#length) test_fun_~y_ref~2.base)|
 (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda))
 (= ray_test_fun_~x_ref~2.offset (* ray_test_fun_~x_ref~2.offset lambda))
 (= ray_test_fun_~c~2.offset (* ray_test_fun_~c~2.offset lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) (- 1)) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 1) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 1) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 (- 1))) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 1)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) (- 1))
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) (- 1))
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 1)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) (- 1)) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 1)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) (- 1))
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 1)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) (- 1))
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) (- 1))
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 1)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) (- 1))
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 1)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) (- 1))
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 1)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) (- 1))
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (- 1)) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) (- 1))
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 1) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 1)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| (- 1)) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) (- 1))
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 1) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) (- 1))
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 1)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) (- 1))
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 1)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) (- 1))
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 1)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) (- 1))
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0) (= lambda lambda))
 (and
 (= |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|))
 (= |honda_test_fun_#t~malloc2.base|
 (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|))
 (= honda_test_fun_~c~2.base
 (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base))
 (= |honda_(select #length test_fun_~y_ref~2.base)|
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|))
 (=
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|))
 (= |honda_test_fun_#in~y| (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|))
 (= |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|))
 (= |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|))
 (= |honda_test_fun_#t~mem6|
 (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|))
 (= |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|))
 (= |honda_test_fun_#t~malloc1.base|
 (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|))
 (= |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|))
 (= |honda_test_fun_#t~malloc2.offset|
 (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|))
 (= |honda_test_fun_#t~mem7|
 (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= honda_test_fun_~y (+ honda_test_fun_~y ray_test_fun_~y))
 (= |honda_test_fun_#t~malloc0.offset|
 (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|))
 (= |honda_(select old(#length) test_fun_~c~2.base)|
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|))
 (=
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|))
 (= honda_test_fun_~y_ref~2.base
 (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base))
 (= honda_test_fun_~x (+ honda_test_fun_~x ray_test_fun_~x))
 (= |honda_(select #length test_fun_~c~2.base)|
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|))
 (= |honda_test_fun_#t~malloc0.base|
 (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|))
 (= |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|))
 (= |honda_test_fun_#t~malloc1.offset|
 (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|))
 (= |honda_(ite test_fun_#t~short8 1 0)|
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|))
 (= honda_test_fun_~x_ref~2.base
 (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base))
 (= honda_test_fun_~y_ref~2.offset
 (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_(select old(#length) test_fun_~x_ref~2.base)|
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|))
 (= |honda_test_fun_#t~mem15|
 (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|))
 (= |honda_(select #length test_fun_~x_ref~2.base)|
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|))
 (=
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= |honda_test_fun_#in~x| (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|))
 (= |honda_(select old(#length) test_fun_~y_ref~2.base)|
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|))
 (= honda_test_fun_~x_ref~2.offset
 (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset))
 (= honda_test_fun_~c~2.offset
 (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 (- 1))
 (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 1) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 1) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 (- 1)) (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 1)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) (- 1))
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 4)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) (- 1))
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 1)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 (- 1)) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 1) 1) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) (- 1))
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 1)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 (- 1))
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 1)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 1)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 1)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) (- 1))
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 4)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 1)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 1)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) (- 1))
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 1) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (- 1)) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 (- 1))
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 1) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 1)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| (- 1)) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 1) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) (- 1))
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 1)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) (- 1))
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 1)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 1) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 (- 1))
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 1)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) (- 1))
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 1)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 1)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 4)) 0)
 (= |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda))
 (= |ray_test_fun_#t~malloc2.base| (* |ray_test_fun_#t~malloc2.base| lambda))
 (= ray_test_fun_~c~2.base (* ray_test_fun_~c~2.base lambda))
 (= |ray_(select #length test_fun_~y_ref~2.base)|
 (* |ray_(select #length test_fun_~y_ref~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda)) (= |ray_test_fun_#in~y| (* |ray_test_fun_#in~y| lambda))
 (= |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|
 (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda))
 (= |ray_test_fun_#t~mem6| (* |ray_test_fun_#t~mem6| lambda))
 (= |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda))
 (= |ray_test_fun_#t~malloc1.base| (* |ray_test_fun_#t~malloc1.base| lambda))
 (= |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda))
 (= |ray_test_fun_#t~malloc2.offset|
 (* |ray_test_fun_#t~malloc2.offset| lambda))
 (= |ray_test_fun_#t~mem7| (* |ray_test_fun_#t~mem7| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= ray_test_fun_~y (* ray_test_fun_~y lambda))
 (= |ray_test_fun_#t~malloc0.offset|
 (* |ray_test_fun_#t~malloc0.offset| lambda))
 (= |ray_(select old(#length) test_fun_~c~2.base)|
 (* |ray_(select old(#length) test_fun_~c~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda))
 (= ray_test_fun_~y_ref~2.base (* ray_test_fun_~y_ref~2.base lambda))
 (= ray_test_fun_~x (* ray_test_fun_~x lambda))
 (= |ray_(select #length test_fun_~c~2.base)|
 (* |ray_(select #length test_fun_~c~2.base)| lambda))
 (= |ray_test_fun_#t~malloc0.base| (* |ray_test_fun_#t~malloc0.base| lambda))
 (= |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda))
 (= |ray_test_fun_#t~malloc1.offset|
 (* |ray_test_fun_#t~malloc1.offset| lambda))
 (= |ray_(ite test_fun_#t~short8 1 0)|
 (* |ray_(ite test_fun_#t~short8 1 0)| lambda))
 (= ray_test_fun_~x_ref~2.base (* ray_test_fun_~x_ref~2.base lambda))
 (= ray_test_fun_~y_ref~2.offset (* ray_test_fun_~y_ref~2.offset lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_(select old(#length) test_fun_~x_ref~2.base)|
 (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda))
 (= |ray_test_fun_#t~mem15| (* |ray_test_fun_#t~mem15| lambda))
 (= |ray_(select #length test_fun_~x_ref~2.base)|
 (* |ray_(select #length test_fun_~x_ref~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda)) (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= |ray_test_fun_#in~x| (* |ray_test_fun_#in~x| lambda))
 (= |ray_(select old(#length) test_fun_~y_ref~2.base)|
 (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda))
 (= ray_test_fun_~x_ref~2.offset (* ray_test_fun_~x_ref~2.offset lambda))
 (= ray_test_fun_~c~2.offset (* ray_test_fun_~c~2.offset lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) (- 1)) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 1) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 1) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 (- 1))) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 1)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) (- 1))
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) (- 1))
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 1)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) (- 1)) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 1)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) (- 1))
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 1)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) (- 1))
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) (- 1))
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 1)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 1)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) (- 1))
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 1)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 1)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) (- 1))
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (- 1)) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) (- 1))
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 1) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 1)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| (- 1)) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) (- 1))
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 1) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) (- 1))
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 1)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) (- 1))
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 1)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) (- 1))
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 1)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) (- 1))
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0) (= lambda lambda))
 (and
 (= |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|))
 (= |honda_test_fun_#t~malloc2.base|
 (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|))
 (= honda_test_fun_~c~2.base
 (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base))
 (= |honda_(select #length test_fun_~y_ref~2.base)|
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|))
 (=
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|))
 (= |honda_test_fun_#in~y| (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|))
 (= |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|))
 (= |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|))
 (= |honda_test_fun_#t~mem6|
 (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|))
 (= |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|))
 (= |honda_test_fun_#t~malloc1.base|
 (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|))
 (= |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|))
 (= |honda_test_fun_#t~malloc2.offset|
 (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|))
 (= |honda_test_fun_#t~mem7|
 (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= honda_test_fun_~y (+ honda_test_fun_~y ray_test_fun_~y))
 (= |honda_test_fun_#t~malloc0.offset|
 (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|))
 (= |honda_(select old(#length) test_fun_~c~2.base)|
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|))
 (=
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|))
 (= honda_test_fun_~y_ref~2.base
 (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base))
 (= honda_test_fun_~x (+ honda_test_fun_~x ray_test_fun_~x))
 (= |honda_(select #length test_fun_~c~2.base)|
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|))
 (= |honda_test_fun_#t~malloc0.base|
 (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|))
 (= |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|))
 (= |honda_test_fun_#t~malloc1.offset|
 (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|))
 (= |honda_(ite test_fun_#t~short8 1 0)|
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|))
 (= honda_test_fun_~x_ref~2.base
 (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base))
 (= honda_test_fun_~y_ref~2.offset
 (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_(select old(#length) test_fun_~x_ref~2.base)|
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|))
 (= |honda_test_fun_#t~mem15|
 (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|))
 (= |honda_(select #length test_fun_~x_ref~2.base)|
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|))
 (=
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= |honda_test_fun_#in~x| (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|))
 (= |honda_(select old(#length) test_fun_~y_ref~2.base)|
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|))
 (= honda_test_fun_~x_ref~2.offset
 (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset))
 (= honda_test_fun_~c~2.offset
 (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 (- 1))
 (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 1) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 1) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 (- 1)) (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 1)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) (- 1))
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 4)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) (- 1))
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 1)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 (- 1)) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 1) 1) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) (- 1))
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 1)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 (- 1))
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 1)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 1)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 1)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) (- 1))
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 4)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 1)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 1) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (- 1)) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 (- 1))
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 1) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 1)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| (- 1)) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 1) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) (- 1))
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 1)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) (- 1))
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 1)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 1) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 (- 1))
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 1)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) (- 1))
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 1)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) (- 1))
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 1)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 1)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 4)) 0)
 (= |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda))
 (= |ray_test_fun_#t~malloc2.base| (* |ray_test_fun_#t~malloc2.base| lambda))
 (= ray_test_fun_~c~2.base (* ray_test_fun_~c~2.base lambda))
 (= |ray_(select #length test_fun_~y_ref~2.base)|
 (* |ray_(select #length test_fun_~y_ref~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda)) (= |ray_test_fun_#in~y| (* |ray_test_fun_#in~y| lambda))
 (= |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|
 (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda))
 (= |ray_test_fun_#t~mem6| (* |ray_test_fun_#t~mem6| lambda))
 (= |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda))
 (= |ray_test_fun_#t~malloc1.base| (* |ray_test_fun_#t~malloc1.base| lambda))
 (= |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda))
 (= |ray_test_fun_#t~malloc2.offset|
 (* |ray_test_fun_#t~malloc2.offset| lambda))
 (= |ray_test_fun_#t~mem7| (* |ray_test_fun_#t~mem7| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= ray_test_fun_~y (* ray_test_fun_~y lambda))
 (= |ray_test_fun_#t~malloc0.offset|
 (* |ray_test_fun_#t~malloc0.offset| lambda))
 (= |ray_(select old(#length) test_fun_~c~2.base)|
 (* |ray_(select old(#length) test_fun_~c~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda))
 (= ray_test_fun_~y_ref~2.base (* ray_test_fun_~y_ref~2.base lambda))
 (= ray_test_fun_~x (* ray_test_fun_~x lambda))
 (= |ray_(select #length test_fun_~c~2.base)|
 (* |ray_(select #length test_fun_~c~2.base)| lambda))
 (= |ray_test_fun_#t~malloc0.base| (* |ray_test_fun_#t~malloc0.base| lambda))
 (= |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda))
 (= |ray_test_fun_#t~malloc1.offset|
 (* |ray_test_fun_#t~malloc1.offset| lambda))
 (= |ray_(ite test_fun_#t~short8 1 0)|
 (* |ray_(ite test_fun_#t~short8 1 0)| lambda))
 (= ray_test_fun_~x_ref~2.base (* ray_test_fun_~x_ref~2.base lambda))
 (= ray_test_fun_~y_ref~2.offset (* ray_test_fun_~y_ref~2.offset lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_(select old(#length) test_fun_~x_ref~2.base)|
 (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda))
 (= |ray_test_fun_#t~mem15| (* |ray_test_fun_#t~mem15| lambda))
 (= |ray_(select #length test_fun_~x_ref~2.base)|
 (* |ray_(select #length test_fun_~x_ref~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda)) (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= |ray_test_fun_#in~x| (* |ray_test_fun_#in~x| lambda))
 (= |ray_(select old(#length) test_fun_~y_ref~2.base)|
 (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda))
 (= ray_test_fun_~x_ref~2.offset (* ray_test_fun_~x_ref~2.offset lambda))
 (= ray_test_fun_~c~2.offset (* ray_test_fun_~c~2.offset lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) (- 1)) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 1) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 1) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 (- 1))) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 1)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) (- 1))
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) (- 1))
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 1)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) (- 1)) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 1)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) (- 1))
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 1)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) (- 1))
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) (- 1))
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 1)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 1)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) (- 1))
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 1)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (- 1)) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) (- 1))
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 1) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 1)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| (- 1)) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) (- 1))
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 1) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) (- 1))
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 1)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) (- 1))
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 1)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) (- 1))
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) (- 1))
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 1)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 1)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) (- 1))
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0) (= lambda lambda))
 (and
 (= |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|))
 (= |honda_test_fun_#t~malloc2.base|
 (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|))
 (= honda_test_fun_~c~2.base
 (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base))
 (= |honda_(select #length test_fun_~y_ref~2.base)|
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|))
 (=
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|))
 (= |honda_test_fun_#in~y| (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|))
 (= |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|))
 (= |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|))
 (= |honda_test_fun_#t~mem6|
 (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|))
 (= |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|))
 (= |honda_test_fun_#t~malloc1.base|
 (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|))
 (= |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|))
 (= |honda_test_fun_#t~malloc2.offset|
 (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|))
 (= |honda_test_fun_#t~mem7|
 (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= honda_test_fun_~y (+ honda_test_fun_~y ray_test_fun_~y))
 (= |honda_test_fun_#t~malloc0.offset|
 (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|))
 (= |honda_(select old(#length) test_fun_~c~2.base)|
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|))
 (=
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|))
 (= honda_test_fun_~y_ref~2.base
 (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base))
 (= honda_test_fun_~x (+ honda_test_fun_~x ray_test_fun_~x))
 (= |honda_(select #length test_fun_~c~2.base)|
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|))
 (= |honda_test_fun_#t~malloc0.base|
 (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|))
 (= |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|))
 (= |honda_test_fun_#t~malloc1.offset|
 (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|))
 (= |honda_(ite test_fun_#t~short8 1 0)|
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|))
 (= honda_test_fun_~x_ref~2.base
 (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base))
 (= honda_test_fun_~y_ref~2.offset
 (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_(select old(#length) test_fun_~x_ref~2.base)|
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|))
 (= |honda_test_fun_#t~mem15|
 (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|))
 (= |honda_(select #length test_fun_~x_ref~2.base)|
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|))
 (=
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= |honda_test_fun_#in~x| (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|))
 (= |honda_(select old(#length) test_fun_~y_ref~2.base)|
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|))
 (= honda_test_fun_~x_ref~2.offset
 (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset))
 (= honda_test_fun_~c~2.offset
 (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 (- 1))
 (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 1) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 1) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 (- 1)) (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 1)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) (- 1))
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 4)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) (- 1))
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 1)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 (- 1)) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 1) 1) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) (- 1))
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 1)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 (- 1))
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 1)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 1)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 (- 1))
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 1)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) (- 1))
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 4)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 1) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (- 1)) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) (- 1))
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 1)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 (- 1))
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 1) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 1)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| (- 1)) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 1) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) (- 1))
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 1)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) (- 1))
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 1)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 1) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 (- 1))
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 1)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 1)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 4)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 1)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) (- 1))
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 1)) 0)
 (= |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda))
 (= |ray_test_fun_#t~malloc2.base| (* |ray_test_fun_#t~malloc2.base| lambda))
 (= ray_test_fun_~c~2.base (* ray_test_fun_~c~2.base lambda))
 (= |ray_(select #length test_fun_~y_ref~2.base)|
 (* |ray_(select #length test_fun_~y_ref~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda)) (= |ray_test_fun_#in~y| (* |ray_test_fun_#in~y| lambda))
 (= |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|
 (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda))
 (= |ray_test_fun_#t~mem6| (* |ray_test_fun_#t~mem6| lambda))
 (= |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda))
 (= |ray_test_fun_#t~malloc1.base| (* |ray_test_fun_#t~malloc1.base| lambda))
 (= |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda))
 (= |ray_test_fun_#t~malloc2.offset|
 (* |ray_test_fun_#t~malloc2.offset| lambda))
 (= |ray_test_fun_#t~mem7| (* |ray_test_fun_#t~mem7| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= ray_test_fun_~y (* ray_test_fun_~y lambda))
 (= |ray_test_fun_#t~malloc0.offset|
 (* |ray_test_fun_#t~malloc0.offset| lambda))
 (= |ray_(select old(#length) test_fun_~c~2.base)|
 (* |ray_(select old(#length) test_fun_~c~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda))
 (= ray_test_fun_~y_ref~2.base (* ray_test_fun_~y_ref~2.base lambda))
 (= ray_test_fun_~x (* ray_test_fun_~x lambda))
 (= |ray_(select #length test_fun_~c~2.base)|
 (* |ray_(select #length test_fun_~c~2.base)| lambda))
 (= |ray_test_fun_#t~malloc0.base| (* |ray_test_fun_#t~malloc0.base| lambda))
 (= |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda))
 (= |ray_test_fun_#t~malloc1.offset|
 (* |ray_test_fun_#t~malloc1.offset| lambda))
 (= |ray_(ite test_fun_#t~short8 1 0)|
 (* |ray_(ite test_fun_#t~short8 1 0)| lambda))
 (= ray_test_fun_~x_ref~2.base (* ray_test_fun_~x_ref~2.base lambda))
 (= ray_test_fun_~y_ref~2.offset (* ray_test_fun_~y_ref~2.offset lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_(select old(#length) test_fun_~x_ref~2.base)|
 (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda))
 (= |ray_test_fun_#t~mem15| (* |ray_test_fun_#t~mem15| lambda))
 (= |ray_(select #length test_fun_~x_ref~2.base)|
 (* |ray_(select #length test_fun_~x_ref~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda)) (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= |ray_test_fun_#in~x| (* |ray_test_fun_#in~x| lambda))
 (= |ray_(select old(#length) test_fun_~y_ref~2.base)|
 (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda))
 (= ray_test_fun_~x_ref~2.offset (* ray_test_fun_~x_ref~2.offset lambda))
 (= ray_test_fun_~c~2.offset (* ray_test_fun_~c~2.offset lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) (- 1)) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 1) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 1) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 (- 1))) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 1)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) (- 1))
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) (- 1))
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 1)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) (- 1)) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 1)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) (- 1))
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 1)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) (- 1))
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) (- 1))
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 1)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) (- 1))
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 1)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) (- 1))
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (- 1)) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) (- 1))
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 1)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) (- 1))
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 1) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 1)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| (- 1)) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) (- 1))
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 1) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) (- 1))
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 1)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) (- 1))
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 1)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) (- 1))
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 1)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) (- 1))
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0) (= lambda lambda))
 (and
 (= |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|))
 (= |honda_test_fun_#t~malloc2.base|
 (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|))
 (= honda_test_fun_~c~2.base
 (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base))
 (= |honda_(select #length test_fun_~y_ref~2.base)|
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|))
 (=
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|))
 (= |honda_test_fun_#in~y| (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|))
 (= |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|))
 (= |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|))
 (= |honda_test_fun_#t~mem6|
 (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|))
 (= |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|))
 (= |honda_test_fun_#t~malloc1.base|
 (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|))
 (= |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|))
 (= |honda_test_fun_#t~malloc2.offset|
 (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|))
 (= |honda_test_fun_#t~mem7|
 (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= honda_test_fun_~y (+ honda_test_fun_~y ray_test_fun_~y))
 (= |honda_test_fun_#t~malloc0.offset|
 (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|))
 (= |honda_(select old(#length) test_fun_~c~2.base)|
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|))
 (=
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|))
 (= honda_test_fun_~y_ref~2.base
 (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base))
 (= honda_test_fun_~x (+ honda_test_fun_~x ray_test_fun_~x))
 (= |honda_(select #length test_fun_~c~2.base)|
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|))
 (= |honda_test_fun_#t~malloc0.base|
 (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|))
 (= |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|))
 (= |honda_test_fun_#t~malloc1.offset|
 (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|))
 (= |honda_(ite test_fun_#t~short8 1 0)|
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|))
 (= honda_test_fun_~x_ref~2.base
 (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base))
 (= honda_test_fun_~y_ref~2.offset
 (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_(select old(#length) test_fun_~x_ref~2.base)|
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|))
 (= |honda_test_fun_#t~mem15|
 (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|))
 (= |honda_(select #length test_fun_~x_ref~2.base)|
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|))
 (=
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= |honda_test_fun_#in~x| (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|))
 (= |honda_(select old(#length) test_fun_~y_ref~2.base)|
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|))
 (= honda_test_fun_~x_ref~2.offset
 (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset))
 (= honda_test_fun_~c~2.offset
 (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 (- 1))
 (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 1) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 1) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 (- 1)) (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 1)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) (- 1))
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 4)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) (- 1))
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 1)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 (- 1)) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 1) 1) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) (- 1))
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 1)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 (- 1))
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 1)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 1)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 1)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) (- 1))
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 4)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 1)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 1)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) (- 1))
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 1) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (- 1)) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 (- 1))
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 1) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 1)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| (- 1)) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 1) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) (- 1))
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 1)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) (- 1))
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 1)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 1) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 (- 1))
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 1)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) (- 1))
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 0)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 1)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_test_fun_#t~malloc2.base| |ray_test_fun_#t~malloc2.base|) 0)
 (* (+ honda_test_fun_~c~2.base ray_test_fun_~c~2.base) 0)
 (*
 (+ |honda_(select #length test_fun_~y_ref~2.base)|
 |ray_(select #length test_fun_~y_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ |honda_test_fun_#in~y| |ray_test_fun_#in~y|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~c~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~mem6| |ray_test_fun_#t~mem6|) 0)
 (*
 (+ |honda_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.base| |ray_test_fun_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc2.offset| |ray_test_fun_#t~malloc2.offset|)
 0) (* (+ |honda_test_fun_#t~mem7| |ray_test_fun_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_test_fun_~y ray_test_fun_~y) 0)
 (* (+ |honda_test_fun_#t~malloc0.offset| |ray_test_fun_#t~malloc0.offset|)
 0) (* (+ |honda_test_fun_#t~mem16| |ray_test_fun_#t~mem16|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~c~2.base)|
 |ray_(select old(#length) test_fun_~c~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0) (* (+ honda_test_fun_~y_ref~2.base ray_test_fun_~y_ref~2.base) 0)
 (* (+ honda_test_fun_~x ray_test_fun_~x) 0)
 (*
 (+ |honda_(select #length test_fun_~c~2.base)|
 |ray_(select #length test_fun_~c~2.base)|) 1)
 (* (+ |honda_test_fun_#t~malloc0.base| |ray_test_fun_#t~malloc0.base|) 0)
 (* (+ |honda_test_fun_#t~mem18| |ray_test_fun_#t~mem18|) 0)
 (*
 (+ |honda_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_test_fun_#t~malloc1.offset| |ray_test_fun_#t~malloc1.offset|)
 0)
 (*
 (+ |honda_(ite test_fun_#t~short8 1 0)| |ray_(ite test_fun_#t~short8 1 0)|)
 0) (* (+ honda_test_fun_~x_ref~2.base ray_test_fun_~x_ref~2.base) 0)
 (* (+ |honda_test_fun_#t~mem11| |ray_test_fun_#t~mem11|) 0)
 (* (+ honda_test_fun_~y_ref~2.offset ray_test_fun_~y_ref~2.offset) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) test_fun_~x_ref~2.base)|
 |ray_(select old(#length) test_fun_~x_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem15| |ray_test_fun_#t~mem15|) 0)
 (* (+ |honda_test_fun_#t~mem12| |ray_test_fun_#t~mem12|) 0)
 (*
 (+ |honda_(select #length test_fun_~x_ref~2.base)|
 |ray_(select #length test_fun_~x_ref~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_test_fun_#in~x| |ray_test_fun_#in~x|) 0)
 (*
 (+ |honda_(select old(#length) test_fun_~y_ref~2.base)|
 |ray_(select old(#length) test_fun_~y_ref~2.base)|) 0)
 (* (+ |honda_test_fun_#t~mem13| |ray_test_fun_#t~mem13|) 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|)
 0) (* (+ honda_test_fun_~x_ref~2.offset ray_test_fun_~x_ref~2.offset) 0)
 (* (+ honda_test_fun_~c~2.offset ray_test_fun_~c~2.offset) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |honda_test_fun_#t~mem16| 0) 
 (* |honda_test_fun_#t~mem18| 0) 
 (* |honda_test_fun_#t~mem11| 0) 
 (* |honda_test_fun_#t~mem12| 0) 
 (* |honda_test_fun_#t~mem13| 0)
 (*
 |honda_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0) (- 4)) 0)
 (= |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda))
 (= |ray_test_fun_#t~malloc2.base| (* |ray_test_fun_#t~malloc2.base| lambda))
 (= ray_test_fun_~c~2.base (* ray_test_fun_~c~2.base lambda))
 (= |ray_(select #length test_fun_~y_ref~2.base)|
 (* |ray_(select #length test_fun_~y_ref~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda)) (= |ray_test_fun_#in~y| (* |ray_test_fun_#in~y| lambda))
 (= |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid test_fun_~c~2.base) 1 0)|
 (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda))
 (= |ray_test_fun_#t~mem6| (* |ray_test_fun_#t~mem6| lambda))
 (= |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda))
 (= |ray_test_fun_#t~malloc1.base| (* |ray_test_fun_#t~malloc1.base| lambda))
 (= |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda))
 (= |ray_test_fun_#t~malloc2.offset|
 (* |ray_test_fun_#t~malloc2.offset| lambda))
 (= |ray_test_fun_#t~mem7| (* |ray_test_fun_#t~mem7| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= ray_test_fun_~y (* ray_test_fun_~y lambda))
 (= |ray_test_fun_#t~malloc0.offset|
 (* |ray_test_fun_#t~malloc0.offset| lambda))
 (= |ray_(select old(#length) test_fun_~c~2.base)|
 (* |ray_(select old(#length) test_fun_~c~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda))
 (= ray_test_fun_~y_ref~2.base (* ray_test_fun_~y_ref~2.base lambda))
 (= ray_test_fun_~x (* ray_test_fun_~x lambda))
 (= |ray_(select #length test_fun_~c~2.base)|
 (* |ray_(select #length test_fun_~c~2.base)| lambda))
 (= |ray_test_fun_#t~malloc0.base| (* |ray_test_fun_#t~malloc0.base| lambda))
 (= |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda))
 (= |ray_test_fun_#t~malloc1.offset|
 (* |ray_test_fun_#t~malloc1.offset| lambda))
 (= |ray_(ite test_fun_#t~short8 1 0)|
 (* |ray_(ite test_fun_#t~short8 1 0)| lambda))
 (= ray_test_fun_~x_ref~2.base (* ray_test_fun_~x_ref~2.base lambda))
 (= ray_test_fun_~y_ref~2.offset (* ray_test_fun_~y_ref~2.offset lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_(select old(#length) test_fun_~x_ref~2.base)|
 (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda))
 (= |ray_test_fun_#t~mem15| (* |ray_test_fun_#t~mem15| lambda))
 (= |ray_(select #length test_fun_~x_ref~2.base)|
 (* |ray_(select #length test_fun_~x_ref~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda)) (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= |ray_test_fun_#in~x| (* |ray_test_fun_#in~x| lambda))
 (= |ray_(select old(#length) test_fun_~y_ref~2.base)|
 (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda))
 (= ray_test_fun_~x_ref~2.offset (* ray_test_fun_~x_ref~2.offset lambda))
 (= ray_test_fun_~c~2.offset (* ray_test_fun_~c~2.offset lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) (- 1)) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 1) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 1) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 (- 1))) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 1)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) (- 1))
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) (- 1))
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 1)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) (- 1)) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 1)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) (- 1))
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 1)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) (- 1))
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) (- 1))
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 1)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 1)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) (- 1))
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 1)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 1)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) (- 1))
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 (- 1)) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) (- 1))
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 1) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 1)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| (- 1)) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) (- 1))
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 1) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) (- 1))
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 1)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) (- 1))
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) (- 1))
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 1)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0)
 (>=
 (+
 (* (* |ray_(ite (select old(#valid) test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#t~malloc2.base| lambda) 0)
 (* (* ray_test_fun_~c~2.base lambda) 0)
 (* (* |ray_(select #length test_fun_~y_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* |ray_test_fun_#in~y| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~mem6| lambda) 0)
 (* (* |ray_(ite (select old(#valid) test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc2.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_test_fun_~y lambda) 0)
 (* (* |ray_test_fun_#t~malloc0.offset| lambda) 0)
 (* (* |ray_test_fun_#t~mem16| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~c~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0) (* (* ray_test_fun_~y_ref~2.base lambda) 0)
 (* (* ray_test_fun_~x lambda) 0)
 (* (* |ray_(select #length test_fun_~c~2.base)| lambda) 1)
 (* (* |ray_test_fun_#t~malloc0.base| lambda) 0)
 (* (* |ray_test_fun_#t~mem18| lambda) 0)
 (* (* |ray_(ite (select #valid test_fun_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_test_fun_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite test_fun_#t~short8 1 0)| lambda) 0)
 (* (* ray_test_fun_~x_ref~2.base lambda) 0)
 (* (* |ray_test_fun_#t~mem11| lambda) 0)
 (* (* ray_test_fun_~y_ref~2.offset lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~x_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem15| lambda) 0)
 (* (* |ray_test_fun_#t~mem12| lambda) 0)
 (* (* |ray_(select #length test_fun_~x_ref~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_test_fun_#in~x| lambda) 0)
 (* (* |ray_(select old(#length) test_fun_~y_ref~2.base)| lambda) 0)
 (* (* |ray_test_fun_#t~mem13| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 lambda) 0) (* (* ray_test_fun_~x_ref~2.offset lambda) 0)
 (* (* ray_test_fun_~c~2.offset lambda) (- 1))
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int test_fun_~y_ref~2.base) test_fun_~y_ref~2.offset)|
 0) (* |ray_test_fun_#t~mem16| 0) 
 (* |ray_test_fun_#t~mem18| 0) 
 (* |ray_test_fun_#t~mem11| 0) 
 (* |ray_test_fun_#t~mem12| 0) 
 (* |ray_test_fun_#t~mem13| 0)
 (*
 |ray_(select (select #memory_int test_fun_~x_ref~2.base) test_fun_~x_ref~2.offset)|
 0)
 (*
 |ray_(select (select #memory_int test_fun_~c~2.base) test_fun_~c~2.offset)|
 0)) 0) (= lambda lambda))) 
 (>= lambda 0)))
(check-sat)
(exit)

